/*
V1. 2010. jan.
-	1 layer  ok.

V2. 2011. marc. 7.
-	1 layer 1 vagy 2bit/pixel, alap text layer

V2. 2011. marc. 13.
-	100MHz-re optomalizalva
-	Grafikus layer bit teritesenek megvaltoztatasa
	LSB...MSB volt eredetileg es MSB...LSB -re valtoztatva
-	Text layer attributum kezeles ok.
-	Ext. karakter generator engedelyezese

V2. 2011 marc. 18. 
-	Atalakitas a CPU_ADDRESS kihagyasa es helyette a
	CPU_RS ( regiszter kivalasztas ) hasznalata, igy 
	kevesebb CPU kivezetes kell a vezerleshez.
-	CPU_BUSY es a CPU_READY kivezetes letrehozasa
	UCF file ennek megfeleloen modositva
-	0, 1, 2, 3, es text layer Ok.
-	Parameterek bevitele soran automatikus reg_select 
	noveles a gyorsabb parameter bevitel erdekeben .
-	layer0_start_preset...layer3_start_preset bit hasznalata 
	hogy csak akkor valtozzon a kezdocim ha mind a ket byte 
	beirasra kerult.
-	MSB...LSB megvaltoztatasa utan a 2bit/pixel layer eseten
	a vilagossag adatokat hibasan olvasta fel mert a bit-ek
	sorrendjet nem vettem figyelembe. Ez korrigalva, de a 
	a karaktergenerator adatbitek sorrendjet is fel kellett cserelni.
	UCF file modositasa es az LCD adatlabak sorrendjenek felcserelese.
-	PLOT, POINT rajzolas funkcioval kiegeszitve. 
-	Sebesseg optimalizalas miatt a Pont rajzolas funkcio 1 orajellel
	hosszabb lett.
-  PLOT, POINT max. koordinatak figyeles
-	LINE DRAW funkcio
-	Egyes funkciok atirasa kulon modulokba
-	SPRITE kezeles
-  SPRITE attributum kezeles

V2. 2011 apr. 6.
-  Pixel es vonal rajzolas a SPRITE-ra is
-  Hibas sprite meret eseten nem ir vagy olvas a 2kbyte-os BRAM-on kivul.

V2.1 2011 jun. 7.
-  Blokk funkcio ROTATE, MIRROR es logikai muveletekkel kiegeszitve.

V2.2 2011 jun. 11.
-  A ligikai muveleteket kozvetlenul a PLOT modul vegzi. Igy minden mas is
   hasznalhatja eza a funkciot.
-  Regiszterek ujrakiosztasa.
-  BLOKK modul ismetelt atirasa a PLOT atirasa miatt
-  A sok atiras soran a POINT funkcio rosszul mukodott, de kijalvitva.
-  CPU_READY jel mukodesenek javitasa
-  LCD frissitesi frekvencia allithato lett ( refress_rate )
-  8 bit-es Setup0_reg helyett csak 1bit van hasznalva a CPU ram prioritas beallitasara,
   a fennmarado bitekbol 5 bit az LCD frissitesi freki beallitashoz
-  Automatikus RAM cim noveles/csokkentes CPU iras vagy olvasas utan -127...+127 tartomanyban
-  Sprite-ok szama 3-ra bovitve. ( 0, 1, 2 )
-  CPU feleol a sprite-ok es az attributum-ok engedelyezese/tiltasa 

V2.3 2011. jun. 17.
-	DALLAS DS2401 azonosito chip hasznalata. Nelkule az LCD kijelzes nem megy :-)
-  SCREEN CAPTURE funkcioval kiegeszitve
-  CPU interface /CE jellel kiegeszitve

V2.4 2011. jul. 15
-	1bit/pixel mod hibas megjelenetesu lett a sok atalakitas miatt de korrigalva lett
-	Automatikus X, Y koordinata noveles lehetoseg
-	Szaggatott vonal rajzolas 16 bit-es dashed_pattern regiszter hasznalataval
-	CIRCLE funkcio
-  CIRCLE korlatozott koriv funkcio ( 1/8 korivek tilas/engedelyezes )
-	A grafikus lapok villogtatasa is lehetseges
-  Layer1...3 beallithato maszknak is ha 1bit/pixel modban van es a layer?_mask_en = 1
	az alatta levo lapokat kitakarja, ha az adott pixel magasabb vagy ugyanolyan fenyereju,
	vagyis a layer?_bright ertek is belejatszik.
-	Regiszterek ujrakiosztasa
-	A chip 81% -on van.

V3.0 2011. jul. 21.
-	UCF file modositasa az uj probapanelnek megfeleloen ez a vegleges labkiosztas
-	Csak 1db RAM chip hasznalata es a 2. RAM /CE jel a DALLAS chip-re kotve.
-	I/O port funkciok megirasanak kezdete.
-  4 x 8bit I/O port
-  4db Rotary encoder a PORT0-ra
-  8db PWM a PORT1-re
-  	3db 8 bit-es PWM kozos eloosztoval
-		1db 8bit-es PWM alacsonyabb frekivel a hangkelteshez, kulon eloosztoval
-  	4db 12 bit-es PWM kozos eloosztoval
-	A chip 93% -on van.

V3.1 2011. jul. 31.
- 	LINE DRAW modul javtva, mert a pixel_ct regiszter ugyanolyan hosszu volt mint az
	x regiszter es ha az x-be maximalis ertek kerul, akkor a vonalhuzas soha nem ert veget,
	ugyanis csak akkor van vege ha a pixel_ct > x. Igy a pixel_ct 1 bit-tel meg lett toldva
-	DALLAS chip sorozatszam regiszterebol 1-byte-tal kevesebbet hasznalok mert eleg a tobbi is.
-	TEXT layer 2-2 grafikus layer koze berakva, hogy a maszkolhato legyen es felette is lehessen grafika 
-	SCOPE modul miatt a BRAM-ok cmkiosztasanak ujraszervezese. A scope mint RAM kezdodik a 0 cimen.
-	SCOPE trigger resz Ok.
-	SCOPE kibovitve PEAK-DETECT moddal es a RAM-ba ennek megfeleloen torteno irassal
-	SCOPE trigger resz a PEAK-DETECT modban is korrekt trigger cimet ad.
-	SCOPE A/D konverter fogadasahoz a bitsorrend megcserelheto, hogy egyszerubb legyen a nyak.
-	SCOPE kibovitve a ROLL modhoz valo regiszterrel ami a minta RAM aktualis irasi cimet tartalmazza.
-	SCOPE interrupt a CPU fele. Csak akkor lesz aktiv ha a nCPU_CE = 1. Igy csak akkor ker megszakitast, 
	ha a chip-et nem hasznalja senki.
-	CPU fele a regiszterek ujrakiosztasa
-	Optimalizalasi beallitasok modositasok, hogy 80MHz-rol is mukodjon a chip. 
	( 80.5MHz-re sikeredett de 17 percre nott a forditasi ido )
-	A chip most 87%-on van, de azt hiszem most van kesz.
	Mar csak a kommentek atnezese es a dokumentacio irogatasa van hatra addig amig tudom mit
	miert csinaltam. :-)
	
V3.2 2012. feb. 16.

- 	Az encoder kezeleshez plusz 1 regiszter beszurasa, hogy az EC85-hoz hasonlo
	gagyi enkodereket is kezelni tudja. Ebben az uzemmodban csak minden masodik
	lepest szamolja.
-	A plusz regiszter miatt a regiszterkiosztas megvaltoztatasa	
	
*/
		
  
module LCD(	CLK_100MHz,
				CLK_OUT,
				LCD_DATA,
				LCD_FRAME,
				LCD_LOAD,
				LCD_CP,
				nLCD_DISP_OFF,
				RAM_ADDRESS,
				RAM_DATA,
				nRAM_CE0,
				DQ, // nRAM_CE1, Csak 1 RAM van, ide a DALLAS Chip DQ-ja van kotve
				nRAM_OE,
				nRAM_WE,	
				nCPU_RD,
				nCPU_WR,
				nCPU_CE,
				CPU_DATA,
				CPU_RS,
				CPU_READY,
				CPU_BUSY,
				nRAM_LB,
				nRAM_UB,
				// I/O PORTOK
				PORT0,
				PORT1,
				PORT2,
				PORT3,
				nIRQ
				
);



//**********************************************
//*** RAM kivezetesekhez tartozo delkaraciok *** 
//**********************************************
//
output [15:0]	RAM_ADDRESS;		// RAM cim 64k
reg	 [15:0]	RAM_ADDRESS = 0; 
inout	 [15:0] 	RAM_DATA;			// RAM adat
output 			nRAM_CE0;			// RAM CE0
reg				nRAM_CE0 	= 1;
//output 			nRAM_CE1;			// RAM CE1
//reg		   		nRAM_CE1 	= 1;
output			nRAM_OE;	    		// RAM OE
reg				nRAM_OE  	= 1;
output			nRAM_WE;				// RAM WE
reg 				nRAM_WE  	= 1;

output			nRAM_LB;				// RAM LB
reg				nRAM_LB = 1;
output			nRAM_UB;				// RAM UB
reg				nRAM_UB = 1;

//**********************************************
//*** CPU kivezetesekhez tartozo deklaraciok ***
//**********************************************
//
input				nCPU_RD;	 			// CPU RD jel aktiv "L" szint
input				nCPU_WR;				// CPU WR jel aktiv "L" szint
input				nCPU_CE;				// CPU CE jel aktiv "L" szint
input				CPU_RS;				// CPU felol regiszter vagy adata kivalasztas
output			CPU_READY;			// Adat iras olvasas kesz jelzes
reg				CPU_READY = 1;
output			CPU_BUSY;			// Pont, vonal stb. GPU muveleteknel foglaltsag jelzes
reg				CPU_BUSY	 = 0;
inout	[7:0]		CPU_DATA;			// CPU felol 8bit-es adatbusz
output			nIRQ;
reg				nIRQ	= 1;

//**********************************************
// LCD kivezetesekhez tartozo deklaraciok
//**********************************************
//
output [3:0]   LCD_DATA; 	      // LCD 4 bit adat
reg    [3:0]   LCD_DATA 		= 0;
output			LCD_FRAME;	      // LCD V sync
output			LCD_LOAD;		   // LCD H sync
output			LCD_CP;		      // LCD clock
output			nLCD_DISP_OFF;		// LCD engedelyezes=1, tiltas=0
reg				nLCD_DISP_OFF	= 0;

//**********************************************
// I/O kivezetesekhez tartozo deklaraciok
//**********************************************
//
inout				DQ;				// DS2401

inout [7:0]	PORT0;
inout [7:0]	PORT1;
inout [7:0]	PORT2;
inout [7:0]	PORT3;
output [1:0]	CLK_OUT;						 
reg	 [1:0]	CLK_OUT = 0;						 


//**************************************************************
// Orajelbemenethez es eloosztokhoz tartozo deklaraciok
//**************************************************************
//
input			   CLK_100MHz;	      			 // 100MHz orajel
wire	ickosc, CLK_100MHz, ck100, ck50, clk; // A belso DLL-ez szukseges deklaraciok 

//**************************************************************
//*** Eldetektalashoz es komparatorokhoz tartozo deklaraciok ***
//**************************************************************
//

reg	[1:0]		ncpu_rd_edge 	 		= 0;	// CPU RD jel eldetektalasahoz mintaveteli shift regiszter
reg	[1:0]		ncpu_wr_edge 	 		= 0;	// CPU WR jel eldetektalasahoz mintaveteli shift regiszter


wire  [6:0]		lcd_x_ct 		 		;	// LCD oszlop szamlalo 0..79  ( 80 x 4 bit 320 oszlop )
wire	[7:0]		lcd_y_ct 		 		;	// LCD sor szamlalo    0..239 ( 240 sor )
wire				lcd_x_ct_max	 		;	// Ha az lcd_x_ct =  79 akkor 1 egyebkent 0.
wire				lcd_y_ct_max	 		;	// Ha az lcd_x_ct = 239 akkor 1 egyebkent 0.
reg	[14:0]	lcd_1bp_addr_pointer	= 0;  // 1bit/pixel Kepernyo relativ cime
reg	[14:0]	lcd_2bp_addr_pointer	= 0;  // 2bit/pixel Kepernyo relativ cime
reg	 [7:0]	lcd_enable				= 0;  // Layer 0=disable 1=enable
														// b7 b6 b5 b4 b3 b2 b1 b0 <- lcd_enable 			
														//  |  |  |  |  |  |  |  |
														//  |  |  |  |  |  |  |   --> text_layer
														//  |  |  |  |  |  |   -----> layer0
														//  |  |  |  |  |   --------> layer1
 														//  |  |  |  |   -----------> layer2
														//  |  |  |   --------------> layer3
														//  |  |   -----------------> 
														//  |   --------------------> lcd_inverse
														//   -----------------------> nLCD_DISP_OFF
														
reg				layer0_enable			= 0;	// Layer0 0=disable 1=enable
reg	[15:0]	layer0_start_addr		= 1200;	// Layer0 RAM kezdocime ( default 2400 ( 0x960 ) )
reg	 [7:0]	layer0_start_lo		= 8'b10110000;	// layer0_start_addr[7:0] reg-be irodik at minden terites elejen
reg	 [7:0]	layer0_start_hi		= 8'b00000100; // layer0_start_addr[15:8] reg-be irodik at minden terites elejen
reg	 			layer0_start_preset	= 0;	// layer0_start_hi beirasakor 1-be irodik
reg	[15:0]	layer0_addr				= 0;	// Layer0 RAM cim
reg	[15:0]	layer0_data				= 0;	// Layer0 RAM-bol felolvasott adat
reg	 [1:0]	layer0_bright			= 3;	// Layer0 fenyero
reg				layer0_bp				= 1;  // Layer0 0 = 1bit/pixel, 1 = 2bit/pixel mod
reg				layer0_blink_en		= 0;	// Layer0 villogas engedelyezes
reg				layer0_blink_inv		= 0;	// Layer0 ellenkezo fazisu villogas

reg				layer1_enable			= 0;	// Layer1 0=disable 1=enable
reg	[15:0]	layer1_start_addr		= 10800;	// Layer1 RAM kezdocime ( default 21600 ( 0x2460 ) )
reg	 [7:0]	layer1_start_lo		= 8'b00110000;	// layer1_start_addr[7:0] reg-be irodik at minden terites elejen
reg	 [7:0]	layer1_start_hi		= 8'b00101010;  // layer1_start_addr[15:8] reg-be irodik at minden terites elejen
reg	 			layer1_start_preset	= 0;	// layer1_start_lo beirasakor 1-be irodik
reg	[15:0]	layer1_addr				= 0;	// Layer1 RAM cim
reg	[15:0]	layer1_data				= 0;	// Layer1 RAM-bol felolvasott adat
reg	 [1:0]	layer1_bright			= 3;	// Layer1 fenyero
reg				layer1_bp				= 1;  // Layer1 0 = 1bit/pixel, 1 = 2bit/pixel mod
reg				layer1_blink_en		= 0;	// Layer1 villogas engedelyezes
reg				layer1_blink_inv		= 0;	// Layer1 ellenkezo fazisu villogas
reg				layer1_mask_en			= 0;	// Ha 1, akkor nem jelenik meg, de kitakarja az alatta levo pixeleket

reg				layer2_enable			= 0;	// Layer2 0=disable 1=enable
reg	[15:0]	layer2_start_addr		= 20400;	// Layer2 RAM kezdocime ( default 40800 ( 0x9F60 ) )
reg	 [7:0]	layer2_start_lo		= 8'b10110000;	// layer2_start_addr[7:0] reg-be irodik at minden terites elejen
reg	 [7:0]	layer2_start_hi		= 8'b01001111;  // layer2_start_addr[15:8] reg-be irodik at minden terites elejen
reg	 			layer2_start_preset	= 0;	// layer2_start_lo beirasakor 1-be irodik
reg	[15:0]	layer2_addr				= 0;	// Layer2 RAM cim
reg	[15:0]	layer2_data				= 0;	// Layer2 RAM-bol felolvasott adat
reg	 [1:0]	layer2_bright			= 3;	// Layer2 fenyero
reg				layer2_bp				= 1;  // Layer2 0 = 1bit/pixel, 1 = 2bit/pixel mod
reg				layer2_blink_en		= 0;	// Layer2 villogas engedelyezes
reg				layer2_blink_inv		= 0;	// Layer2 ellenkezo fazisu villogas
reg				layer2_mask_en			= 0;	// Ha 1, akkor nem jelenik meg, de kitakarja az alatta levo pixeleket

reg				layer3_enable			= 0;	// Layer3 0=disable 1=enable
reg	[15:0]	layer3_start_addr		= 30000;	// Layer3 RAM kezdocime ( default 60000 ( 0xEA60 ) )
reg	 [7:0]	layer3_start_lo		= 8'b00110000;	// layer3_start_addr[7:0] reg-be irodik at minden terites elejen
reg	 [7:0]	layer3_start_hi		= 8'b01110101;  // layer3_start_addr[15:8] reg-be irodik at minden terites elejen
reg	 			layer3_start_preset	= 0;	// layer3_start_lo beirasakor 1-be irodik
reg	[15:0]	layer3_addr				= 0;	// Layer3 RAM cim
reg	[15:0]	layer3_data				= 0;	// Layer3 RAM-bol felolvasott adat
reg	 [1:0]	layer3_bright			= 3;	// Layer3 fenyero
reg				layer3_bp				= 1;  // Layer3 0 = 1bit/pixel, 1 = 2bit/pixel mod
reg				layer3_blink_en		= 0;	// Layer3 villogas engedelyezes
reg				layer3_blink_inv		= 0;	// Layer3 ellenkezo fazisu villogas
reg				layer3_mask_en			= 0;	// Ha 1, akkor nem jelenik meg, de kitakarja az alatta levo pixeleket


reg	[15:0]	layerx_start_addr		= 39600;	// Layerx RAM kezdocime ( default 79200 ( 0x13560 ) )
reg	 [1:0]	layerx_bright			= 3;	// Layerx fenyero
reg				layerx_bp				= 1;  // Layerx 0 = 1bit/pixel, 1 = 2bit/pixel mod


reg				text_layer_enable		= 0;	// Text layer 0=disable 1=enable
reg	[15:0]	text_start_addr		= 0;	// Karakteres kepernyo kezdocime ( default 0 ( 0x0 ) )
reg	 [7:0]	text_start_lo			= 0;	// text_start_addr[7:0] reg-be irodik at minden terites elejen
reg	 [7:0]	text_start_hi			= 0;	// text_start_addr[15:8] reg-be irodik at minden terites elejen
reg	 			text_start_preset		= 0;	// text_start_lo beirasakor 1-be irodik
reg	[10:0]	text_addr_pointer		= 0;  // Karakteres kepernyo relativ cime 0...1199
reg	[15:0]	text_addr				= 0;	// Text layer RAM cim
reg	 [7:0]	char_data				= 0;	// A RAM-bol felolvasott karakter kod 
reg	 [7:0]	char_attr				= 0;	// A RAM-bol felolvasott karakter attributum
														// b7 b6 b5 b4 b3 b2 b1 b0 --> char_attr
														// |  ----- |  |  ----- |
														// |    |   |  |    |    ----> Ext karakter generator
														// |    |   |  |     --------> fenyero 0...3
														// |    |   |   -------------> atlatszosag. 0=igen, 1=nem
														// |    |    ----------------> inverz       0=nem,  1=igen
														// |     --------------------> villogas[0]
														//  -------------------------> Belso ext karakter genarator kivalasztasa
														//
														
wire				graph_blink_bit;				// Villogasi utem a grafikus layerhez lcd_sync modulbol
reg	[3:0]		graph_blink_rate		= 0;	// Grafikus layer-ek villogasi sebessege

wire	 			char_blink_bit;   			// Villogasi utem a Text layerhez az lcd_sync modulbol
reg	 [3:0]	char_blink_rate		= 0;	// Karakter villogasi sebesseg
reg	 [1:0]	char_bright				= 3;	// Karakter fenyero 0...3
reg	 [3:0]	char_line_ct			= 0;	// A karakter tertesnel a sorokat szamolja
reg	 			char_gen_size			= 0;	// karaktergenerator karakter magassag 0=8, 1=12 pont magas
reg	 [3:0]	char_end					= 7;	// A karakter utolso sora 7 vagy 11
reg	 [3:0]	text_cikl				= 0;  // Text layer cikl. reg
reg	 [3:0]	char_size				= 7;	// karakter mret 7...15 ( char_size + 1 a valodi magassag )
reg	 [6:0]	x_ct						= 0; 	// Oszlop szamlalo 0...79
reg	 [7:0]	y_ct						= 0; 	// Oszlop szamlalo 0...239

reg	 [7:0]	cgrom_data				= 0;	// Karaktergenerator adat
reg	[12:0]	cgrom_addr				= 0;  // Karaktergenerator cim ( 4 kbyte )
reg	[16:0]	ext_cgrom_addr			= 0;	// Kulso karakter generator ram cim
reg	[16:0]	ext_cgrom_start_addr	= 98400;	// Kulso karaktergenerator ram kezdo cime ( default 98400 ( 0x18060 ) )
reg	 [7:0]	ext_cgrom_data			= 0;	// Kulso karaktergeneratorbol felolvasott adat
reg	 [7:0]	text_mode				= 0;	// Text layer tulajdonsagok
														// Text layer mode reg
														// b7 b6 b5 b4 b3 b2 b1 b0 			
														//  |  |  |  |  |  |  |  |
														//  |  |  |  |  |  |  |   --> char_gen_size 0=8, 1=12 pont magas
														//  |  |  |  |  |  |   -----> char_size[0]
														//  |  |  |  |  |   --------> char_size[1]
														//  |  |  |  |   -----------> char_size[2]
														//  |  |  |   --------------> char_blink_rate[0]
														//  |  |   -----------------> char_blink_rate[1]
														//  |   --------------------> char_blink_rate[2]
														//   -----------------------> char_blink_rate[3]


reg	[4:0]		data_mixer_cikl		= 0;	// A kulonbozo layer-ek adatainak osszefesulesehez ciklus reg.
reg	[4:0]		sprite_mixer_cikl		= 0;	// Sprite-ok osszefuzesehez cikl. reg.
reg	[7:0]		lcd_data_puffer		= 0;	// 4 pixel adat
reg	[7:0]		sprite_data_puffer	= 0;	// 4 pixel adat
reg	[3:0]		sprite_attr_puffer	= 0;	// 4 pixel attr

reg	[1:0]		lcd_puffer_pointer	= 0;	// Az lcd_data_puffer 4x4 bit-es pixel adatok cimzesere

wire				lcd_cp_elott			;  	// LCD_CP jel felfutasa elott 1 clk idore 1-be irodik

wire				frame_start		 		;  	// LCD terites kezdetet jelzi 1 clk ideig 1-be irodik

reg	[2:0]		lcd_strobe_cikl		= 0;  // Az LCD puffer atirasa, pointerek szamlalok stb ciklus reg.
											

//**************************************************************
// Egyeb belso regiszterek 
//**************************************************************
//
reg	 [7:0]	read_xxx			 = 0;		// CPU fele torteno olvasas gyorstas miatt egy atmeneti regiszter
													// amibol a CPU_DATA buszra teszi ki az olvasott adatot
reg	 			ram_pri			 = 0;		// CPU ram prioritas 0=high 1=low
reg	 [4:0]	refress_rate    = 19;	// LCD_CP frekvencia
reg	 [7:0]	ram_cur_step	 = 0;		// CPU RAM iras/olvasas utan az ebben beallitott erterkkel
													// noveli vagy csokkenti a cpu_ram_address erteket
													// -127...+127 
reg 				rambde			 = 1;		// A RAM irasakor a ezzel van engedelyeze a kimeneti 
													// buszmeghajto a kivezetesek egyseges idozitese miatt.
reg	[15:0]	ram_write_data  = 0;		// RAM-ba irando adat
reg	 [7:0]	cpu_read_data   = 0;		// CPU_ADDRESS = 0 - RAM data --> CPU data
reg	 [7:0]	cpu_write_data  = 0;		// CPU_ADDRESS = 0 - CPU data <-- RAM data
reg	[17:0]	cpu_ram_address = 0;		// A CPU RAM cimregisztere
reg	[17:0]	cpu_tmp_address = 0;		// A CPU RAM cimregiszter ebbol kap erteket
reg	 [7:0]	lcd_reg_select	 = 0;		// a korlatozott 4 bit-es CPU_ADDRESS miatt egyes regiszterek
												   // ennak az erteketol fuggoen erhetok el

reg	 [2:0]	ram_cikl			 = 0; 	// RAM r/w state machine

									


//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
// A belso blokk RAM -hoz valo deklaraciok 
//

reg	[2:0]	bram_cikl			= 0;	// Block ram state machine

reg			bram_write_ready	= 1;	// Block ram iras vegen 1-be irodik
reg			bram_read_ready	= 1;	// Block ram olvasas vegen 1-be irodik

wire	[7:0]	bram_read_data;			// Block ram-bol olvasott adat
reg	[7:0] bram_write_data	= 0;	// Block ram-ba irando adat
reg  [14:0]	bram_addr			= 0;	// Block ram cim

reg		   bram_clk				= 0;	// Port B RAM clock input
reg		   bram_we			   = 0;	// Port B RAM write enable input



// SPRITE
reg	[5:0]	sprite_enable		= 0;  // enable = 1, disable = 0
												// b7 b6 b5 b4 b3 b2 b1 b0    R/W
												// |  |  |  |  |  |  |  |
												// |  |  |  |  |  |  |  \->  Sprite0_En       
												// |  |  |  |  |  |  \---->  Sprite0_Attr_en  
												// |  |  |  |  |  \------->  Sprite1_En       
												// |  |  |  |  \---------->  Sprite1_Attr_en  
												// |  |  |  \------------->  Sprite2_En       
												// |  |  \---------------->  Sprite2_Attr_en  
												// |  \------------------->  nc.
												// \---------------------->  nc.

wire [10:0] sprite0_addr; 				// Port A 10-bit address input
//reg	[7:0] sprite0_data_in    = 0;	// Port A 8-bit data input
wire	[7:0]	sprite0_data_out; 		// Port A 8-bit data output
reg		   sprite0_en    		= 0;	// Sprite0 = 1 engedelyezes 0 tiltas
wire			sprite0_clk;				// Port A clock input
reg		   sprite0_we    		= 0;	// Port A RAM write enable input

wire	[7:0]	bram_sprite0_data_out;	// Port B 8-bit data output
wire		   bram_sprite0_en;			// Port B RAM enable input

wire [10:0] sprite1_addr; 				// Port A 10-bit address input
//reg	[7:0] sprite1_data_in    = 0;	// Port A 8-bit data input
wire	[7:0]	sprite1_data_out; 		// Port A 8-bit data output
reg		   sprite1_en    		= 0;	// Sprite0 = 1 engedelyezes 0 tiltas
wire			sprite1_clk;				// Port A clock input
reg		   sprite1_we    		= 0;	// Port A RAM write enable input

wire	[7:0]	bram_sprite1_data_out;	// Port B 8-bit data output
wire		   bram_sprite1_en;			// Port B RAM enable input

wire [10:0] sprite2_addr; 				// Port A 10-bit address input
//reg	[7:0] sprite2_data_in    = 0;	// Port A 8-bit data input
wire	[7:0]	sprite2_data_out; 		// Port A 8-bit data output
reg		   sprite2_en    		= 0;	// Sprite0 = 1 engedelyezes 0 tiltas
wire			sprite2_clk;				// Port A clock input
reg		   sprite2_we    		= 0;	// Port A RAM write enable input

wire	[7:0]	bram_sprite2_data_out;	// Port B 8-bit data output
wire		   bram_sprite2_en;			// Port B RAM enable input


							
// CGROM
reg	[7:0] cgrom0_data_in		= 0;	// Port A 8-bit data input
reg	[7:0] cgrom1_data_in		= 0;	// Port A 8-bit data input
reg	[7:0] cgrom2_data_in		= 0;	// Port A 8-bit data input

wire	[7:0]	cgrom0_data_out; 			// Port A 8-bit data output
wire	[7:0]	cgrom1_data_out; 			// Port A 8-bit data output
wire	[7:0]	cgrom2_data_out; 			// Port A 8-bit data output

reg		   cgrom0_en    		= 0;	// Port A RAM enable input
reg		   cgrom1_en    		= 0;	// Port A RAM enable input
reg		   cgrom2_en    		= 0;	// Port A RAM enable input

reg			cgrom_clk   		= 0;	// Port A clock input
reg		   cgrom_we    		= 0;	// Port A RAM write enable input



wire	[7:0]	bram_cgrom0_data_out;	// Port B 8-bit data output
wire	[7:0]	bram_cgrom1_data_out;	// Port B 8-bit data output
wire	[7:0]	bram_cgrom2_data_out;	// Port B 8-bit data output

wire		   bram_cgrom0_en;			// Port B RAM enable input
wire		   bram_cgrom1_en;			// Port B RAM enable input
wire		   bram_cgrom2_en;			// Port B RAM enable input




// RAMB16_S9_S9 Spartan3 2048 x 8 Dual-Port RAM
//
   RAMB16_S9_S9 Sprite0_inst (
      .DIA(0),  					    // Port A 8-bit data input
      .DIB(bram_write_data), 		 // Port B 8-bit data input
      .DOA(sprite0_data_out),   	 // Port A 8-bit data output
      .DOB(bram_sprite0_data_out),// Port B 8-bit data output
      .ENA(1),      		 			 // Port A RAM enable input
      .ENB(bram_sprite0_en),      // Port B RAM enable input
      .ADDRA(sprite0_addr[10:0]), // Port A 10-bit address input
      .ADDRB(bram_addr[10:0]),	 // Port B 10-bit address input
	.DOPA(), 							 // Port A 1-bit parity data output
   .DOPB(),								 // Port B 1-bit parity data output
      .CLKA(sprite0_clk),  		 // Port A clock input
      .CLKB(bram_clk),			  	 // Port B clock input
	.DIPA(0),							 // Port A 1-bit parity data input
	.DIPB(0),							 // Port B 1-bit parity data input
   .SSRA(0),   					    // Port A Synchronous reset input
   .SSRB(0),   						 // Port B Synchronous reset input
      .WEA(0),  		  	   		 // Port A RAM write enable input
      .WEB(bram_we)  			    // Port B RAM write enable input
   );
  RAMB16_S9_S9 Sprite1_inst (
      .DIA(0),  					    // Port A 8-bit data input
      .DIB(bram_write_data), 		 // Port B 8-bit data input
      .DOA(sprite1_data_out),   	 // Port A 8-bit data output
      .DOB(bram_sprite1_data_out),// Port B 8-bit data output
      .ENA(1),      		 			 // Port A RAM enable input
      .ENB(bram_sprite1_en),      // Port B RAM enable input
      .ADDRA(sprite1_addr[10:0]), // Port A 10-bit address input
      .ADDRB(bram_addr[10:0]),	 // Port B 10-bit address input
	.DOPA(), 							 // Port A 1-bit parity data output
   .DOPB(),								 // Port B 1-bit parity data output
      .CLKA(sprite1_clk),  		 // Port A clock input
      .CLKB(bram_clk),			  	 // Port B clock input
	.DIPA(0),							 // Port A 1-bit parity data input
	.DIPB(0),							 // Port B 1-bit parity data input
   .SSRA(0),   					    // Port A Synchronous reset input
   .SSRB(0),   						 // Port B Synchronous reset input
      .WEA(0),  		  	   		 // Port A RAM write enable input
      .WEB(bram_we)  			    // Port B RAM write enable input
   );
  RAMB16_S9_S9 Sprite2_inst (
      .DIA(0),  					    // Port A 8-bit data input
      .DIB(bram_write_data), 		 // Port B 8-bit data input
      .DOA(sprite2_data_out),   	 // Port A 8-bit data output
      .DOB(bram_sprite2_data_out),// Port B 8-bit data output
      .ENA(1),      		 			 // Port A RAM enable input
      .ENB(bram_sprite2_en),      // Port B RAM enable input
      .ADDRA(sprite2_addr[10:0]), // Port A 10-bit address input
      .ADDRB(bram_addr[10:0]),	 // Port B 10-bit address input
	.DOPA(), 							 // Port A 1-bit parity data output
   .DOPB(),								 // Port B 1-bit parity data output
      .CLKA(sprite2_clk),  		 // Port A clock input
      .CLKB(bram_clk),			  	 // Port B clock input
	.DIPA(0),							 // Port A 1-bit parity data input
	.DIPB(0),							 // Port B 1-bit parity data input
   .SSRA(0),   					    // Port A Synchronous reset input
   .SSRB(0),   						 // Port B Synchronous reset input
      .WEA(0),  		  	   		 // Port A RAM write enable input
      .WEB(bram_we)  			    // Port B RAM write enable input
   );	

`include "SPRITE_BRAM.v" 
 

RAMB16_S9_S9 RAM0_inst (
      .DIA(cgrom0_data_in),     		// Port A 8-bit data input
      .DIB(bram_write_data),  		// Port B 8-bit data input
      .DOA(cgrom0_data_out),   		// Port A 8-bit data output
      .DOB(bram_cgrom0_data_out),	// Port B 8-bit data output
      .ENA(cgrom0_en),      			// Port A RAM enable input
      .ENB(bram_cgrom0_en),     		// Port B RAM enable input
      .ADDRA(cgrom_addr[10:0]), 		// Port A 10-bit address input
      .ADDRB(bram_addr[10:0]),		// Port B 10-bit address input
	.DOPA(), 					// Port A 1-bit parity data output
   .DOPB(),					// Port B 1-bit parity data output
      .CLKA(cgrom_clk),  				// Port A clock input
      .CLKB(bram_clk), 			  		// Port B clock input
	.DIPA(0),					// Port A 1-bit parity data input
	.DIPB(0),					// Port B 1-bit parity data input
   .SSRA(0),   				// Port A Synchronous reset input
   .SSRB(0),   				// Port B Synchronous reset input
      .WEA(cgrom_we),     				// Port A RAM write enable input
      .WEB(bram_we)      				// Port B RAM write enable input
   );

RAMB16_S9_S9 RAM1_inst (
      .DIA(cgrom1_data_in),     		// Port A 8-bit data input
      .DIB(bram_write_data),  		// Port B 8-bit data input
      .DOA(cgrom1_data_out),   		// Port A 8-bit data output
      .DOB(bram_cgrom1_data_out),	// Port B 8-bit data output
      .ENA(cgrom1_en),      			// Port A RAM enable input
      .ENB(bram_cgrom1_en),     		// Port B RAM enable input
      .ADDRA(cgrom_addr[10:0]), 		// Port A 10-bit address input
      .ADDRB(bram_addr[10:0]),		// Port B 10-bit address input
	.DOPA(), 					// Port A 1-bit parity data output
   .DOPB(),					// Port B 1-bit parity data output
      .CLKA(cgrom_clk),  				// Port A clock input
      .CLKB(bram_clk), 			  		// Port B clock input
	.DIPA(0),					// Port A 1-bit parity data input
	.DIPB(0),					// Port B 1-bit parity data input
   .SSRA(0),   				// Port A Synchronous reset input
   .SSRB(0),   				// Port B Synchronous reset input
      .WEA(cgrom_we),     				// Port A RAM write enable input
      .WEB(bram_we)      				// Port B RAM write enable input
   ); 

RAMB16_S9_S9 RAM2_inst (
      .DIA(cgrom2_data_in),     		// Port A 8-bit data input
      .DIB(bram_write_data),  		// Port B 8-bit data input
      .DOA(cgrom2_data_out),   		// Port A 8-bit data output
      .DOB(bram_cgrom2_data_out),	// Port B 8-bit data output
      .ENA(cgrom2_en),      			// Port A RAM enable input
      .ENB(bram_cgrom2_en),     		// Port B RAM enable input
      .ADDRA(cgrom_addr[10:0]), 		// Port A 10-bit address input
      .ADDRB(bram_addr[10:0]),		// Port B 10-bit address input
	.DOPA(), 					// Port A 1-bit parity data output
   .DOPB(),					// Port B 1-bit parity data output
      .CLKA(cgrom_clk),  				// Port A clock input
      .CLKB(bram_clk), 			  		// Port B clock input
	.DIPA(0),					// Port A 1-bit parity data input
	.DIPB(0),					// Port B 1-bit parity data input
   .SSRA(0),   				// Port A Synchronous reset input
   .SSRB(0),   				// Port B Synchronous reset input
      .WEA(cgrom_we),     				// Port A RAM write enable input
      .WEB(bram_we)      				// Port B RAM write enable input
   );


`include "CG_ROM.v"
`include "Scope_RAM_def.v"

											
											
//**************************************************************
// Grafikahoz valo regiszterek
//**************************************************************


wire 			pixel_ram_ready;
wire 			pixel_read_req;
wire 			pixel_write_req;
wire 			bram_pixel_read_req;
wire 			bram_pixel_write_req;
wire [16:0]	pixel_addr;
wire  [1:0]	point_pixel_bright;
wire	[7:0]	pixel_write_data;
wire			plot_point_ready;
wire			plot_ready;								 

reg	[1:0]	plot_ready_edge	= 0;

wire 			pixel_dashed_pattern;	// A pixel rajzolo modul bemenetere a dashed_pattern reg megfelelo bitje

reg	[3:0]	x_auto_inc					= 0; // plot utani automatikus koordinata noveles +7...-7
reg	[3:0]	y_auto_inc					= 0; // plot utani automatikus koordinata noveles +7...-7

reg  [15:0]	dashed_pattern				= 65535; // Szaggatott vonal rajzolasahoz a mintat tartalmazza
reg	[3:0]	pattern_pointer			= 0;	 // A dashed_pattern regisztert cimzi

reg	[3:0]	function_select			= 0;	// Ennek erteketol fuggoen fogja elinditani
														// a grafikai modulokat es a parameter betoltes is
														// ennek megfeleloen fog megtortenni
														// 0 = pont 
														// 1 = vonal
														// 2 = kor
														// 3 = blokk
reg			cpu_plot_start				= 0;  // CPU felol pixel rajz inditas, 1 clk ideig
reg			cpu_point_start			= 0;  // CPU felol pixel olvasas inditas, 1 clk ideig
reg			cpu_line_draw_start 		= 0;	// CPU felol vonalhuzas inditas, 1 clk ideig
reg			cpu_circle_start			= 0;  // CPU felol kor rajz inditas, 1 clk ideig
reg			cpu_block_start			= 0;  // CPU felol blokk muvelet inditas, 1 clk ideig


// Screen capture regiszterei
reg				screen_capture_start = 0; 		// 1-be irva inditja a kepernyo mentest a 
															// layerx cimetol kezdodoen 2bit/pixel modban
reg	 [1:0]	capture_state			= 0;		// capture case state machine
reg 	[16:0]	capture_ram_address	= 0;		// RAM cimzesehez kell															
reg	 [7:0]	capture_write_data	= 0;     // RAM-ba irando adat
reg				capture_write_ready  = 0;		// 1 ha kesz az iras
reg	[14:0]	capture_ct				= 0;		// A mentes relativ cime ( 0...19199 )



// Pixel rajzolas es olvasas
wire	 [8:0]		pixel_out_x;				// A pixel modul aktualisan kiirt pixel x koordinataja
wire	 [7:0]		pixel_out_y;				// A pixel modul aktualisan kiirt pixel y koordinataja
wire					point_attr;
reg					plot_stop;
reg	 [8:0]		max_plot_ct			 = 0; // Ha nem 0, akkor a vonal vagy kor rajzolasnal
														// az itt beallitott szamu pixel kirajzolasa utan
														// a PLOT funkcio tiltva lesz. 
														// Ha plot_ct = max_plot_ct akkor plot_stop = 1
reg	 [8:0]		plot_ct				 = 0; // A kirajzolt pontokat szamolja.
reg					plot_attr			 = 0;
reg					sprite_attr_write_en = 0; // Sprite attr. iras 0=tiltva, 1=engedelyezve
reg					pixel_bp				 = 0; // pixel/bit 0=1bit/pixel, 1=2bit/pixel
reg	 [3:0]	   pixel_write_mode	 = 0; // 0 = Normal
														// 1 = Overwrite
														// 2 = OR
														// 3 = XOR
														// 4 = AND
														// 5 = INVERZ
														// 6 = Bright DEC
														// 7 = Bright INC


reg	 [8:0]		x						 = 0;	// pont x koordinataja 
reg	 [7:0]		y						 = 0;	// pont y koordinataja 
reg	 [1:0]		plot_pixel_bright	 = 0;	// pont rajzolasnal ebben van a pont fenyereje
reg	 [7:0]		pixel_read_data 	 = 0;	// az egy byte-ban levo pixelek adatai
reg	 [2:0]		layer_select		 = 0; // 0,1,2,3,4 A 4. layer virtualis nincs megjelenitve
														// A 4. layer ertek arra jo, hogy erre rajzolva
														// barmelyik masik kezdocimenek be lehet allitani es
														// akkor megjelenik, de rajzolas kozben nem kell
														// latszania

// Vonal rajzolas

reg	[8:0]		x1;								// Vegpont koordinata
reg	[7:0]		y1;								// Vegpont koordinata

wire				line_draw_plot_start;	   // Vonalhuzo modul pont rajzolas inditas, 1 clk ideig
wire	[8:0]		line_draw_x_out;				// Vonalhuzo modulbol a kiszamitott pont x koordinataja
wire	[7:0]		line_draw_y_out;				// Vonalhuzo modulbol a kiszamitott pont y koordinataja
wire				line_draw_ready;				// 1 ha kesz a vonal
wire				line_draw_busy;				// 1 ha folzamatban van a vonal rajzolas

//reg	clk_div = 0;
//BUFG CLK25MHZ (.I( clk_div), .O( clk2) );
//always @ ( posedge CLK_100MHz ) begin
//	clk_div <= clk_div + 1;
//end


line_draw	LINE1(	.clk ( clk ),									// <- 1 bit Orajel
							.start ( cpu_line_draw_start ),			// <- 1 bit Inditojel 1 clk ideig
							.start_x ( x ),							   // <- 9 bit kezdopont x koordinata
							.start_y ( y ),								// <- 8 bit kezdopont y koordinata
							.end_x ( x1 ),									// <- 9 bit vegpont x koordinata
							.end_y ( y1 ),									// <- 8 bit vegpont y koordinata
							.x ( line_draw_x_out ),						// -> 9 bit kiszamitott x koordinata
							.y ( line_draw_y_out ),						// -> 8 bit kiszamitott y koordinata
							.plot_start ( line_draw_plot_start ),	// -> 1 bit pixel rajzolas inditas
							.plot_ready ( plot_point_ready ),		// -> 1 bit pixel modul kesz jelzes
							.ready ( line_draw_ready )					// -> 1 bit vonalrajzolas kesz jelzes
						);

wire			circle_plot_start;
wire	[8:0]	circle_x_out;
wire	[7:0]	circle_y_out;
wire			circle_ready;

circle		CIRCLE1( .clk ( clk ),
							.start ( cpu_circle_start ),
							.center_x ( x ),
							.center_y ( y ),
							.radius ( x1 ),
							.deg ( y1 ),
							.plot_ready ( plot_point_ready ),
							.plot_start ( circle_plot_start ),
							.x_out ( circle_x_out ),
							.y_out ( circle_y_out ),
							.ready ( circle_ready )
							);

// Blokk muvelet
reg	[2:0]		source_layer		= 0; // forras layer kivalasztasa
												  // 0 = layer0
												  // 1 = layer1
												  // 2 = layer2
												  // 3 = layer3
												  // 4 = layerx
												  // 5 = sprite0
												  // 6 = sprite1
												  // 7 = sprite2
reg	[2:0]		target_layer		= 0; // cel layer kivalasztasa
												  // 0 = layer0
												  // 1 = layer1
												  // 2 = layer2
												  // 3 = layer3
												  // 4 = layerx
												  // 5 = sprite0
												  // 6 = sprite1
												  // 7 = sprite2
reg				source_layer_bp	= 0; // 0 = 1bit/pixel, 1 = 2bit/pixel
reg				target_layer_bp	= 0; // 0 = 1bit/pixel, 1 = 2bit/pixel
reg	[8:0]		block_width			= 0; // Blokk szelessege pixelben 0-319
reg	[7:0]		block_height		= 0; // Blokk magassag pixelben 0-239
reg	[4:0]		block_mode			= 0; // Blokk muvelet tulajdonsagai
												  // bit[0]		0=Normal, 1=MOVE
												  // bit[1]    0=Normal, 1=FILL
												  // bit[2]		0=MIRROR, 1=ROTATE
												  // 	bit[4:3] 	0= no mirror
												  //			  		1= x mirror
												  //					2= y mirror
												  //					3= xy mirror
												  // 	bit[4:3]		0=   0 deg rotate
												  //					1=  90 deg rotate
												  //					2= 180 deg rotate
												  //					3= 270 deg rotate												  
reg	[1:0]		block_fill_bright 		= 0; // Blokk muveletnel a kitoltes fenyereje
wire				block_plot_start;				  // Blokk modul pixel rajzolas keres 1 clk ideig 1
wire				block_point_start;			  // Blokk modul pixel olvasas keres 1 clk ideig 1
wire	[8:0]		block_x_out;					  // Blokk modul kiszamitott pont x koordinata
wire	[7:0]		block_y_out;					  // Blokk modul kiszamitott pont y koordinata
wire				block_pixel_bp;				  // Blokk modul bit/pixel felbontas a pixel modul fele
wire	[1:0]		block_plot_pixel_bright;	  // Blokk modul pixel fenyero a pixel modul fele
wire	[2:0]		block_layer_select;			  // Blokk modul layer kivalasztas a pixel modul fele
wire				block_ready;					  // 1-be irodik ha a blokk muvelet kesz


pixel_block		BLK1(	.clk( clk ),												// <- 1 bit orajel
							.start( cpu_block_start ),								// <- 1 bit start jel
							.s_x( x ),													// <- 9 bit forras x koordinata
							.s_y( y ),													// <- 8 bit forras y koordinata
							.t_x( x1 ),													// <- 9 bit cel x koordinata 
							.t_y( y1 ),													// <- 8 bit cel y koordinata
							.b_w( block_width ),										// <- 9 bit blokk szelesseg
							.b_h( block_height ),	  								// <- 8 bit blokk magassag
							.source_layer( source_layer ),						// <- 3 bit forras oldal
							.target_layer( target_layer ),						// <- 3 bit cel oldal
							.source_layer_bp( source_layer_bp ), 				// <- 1 bit forras bit/pixel felbontas
							.target_layer_bp( target_layer_bp ), 				// <- 1 bit cel bit/pixel felbontas
							.block_mode( block_mode ),				 				// <- 5 bit blokk muvelet tulajdonsagok
							.block_fill_bright( block_fill_bright ), 			// <- 2 bit kitolto pixel fenyero
							.point_pixel_bright( point_pixel_bright ),		// <- 2 bit pixel fenyero a pixel modulbol
							.plot_point_ready( plot_point_ready ),				// <- 1 bit pixel modulbol kesz jelzes
							
							.plot_start( block_plot_start ),						// -> 1 bit pixel modul fele PLOT start jel
							.point_start( block_point_start ),					// -> 1 bit pixel modul fele POINT start jel
							.x( block_x_out ),										// -> 9 bit pixel modul fele x koordinata
							.y( block_y_out ),										// -> 8 bit pixel modul fele y koordinata
							.layer_select( block_layer_select ),				// -> 3 bit pixel modul fele oldal kivalasztas
							.pixel_bp ( block_pixel_bp ),							// -> pixel modul fele bit/pixel mod
							.plot_pixel_bright( block_plot_pixel_bright ), 	// -> 2 bit pixel modul fele pixel fenyero
							.ready( block_ready )								  	// -> 1 bit blokk modul kesz jelzes
						);




// Eldetektalashoz a konstansok
//
parameter Felfuto_el = 1; // a 2bit-es shift regiszterek tartalma 01 ha felfuto el volt
parameter Lefuto_el  = 2; // a 2bit-es shift regiszterek tartalma 10 ha felfuto el volt



//**************************************************************
// Prioritas enkoderhez es RAM muveletekhez tartozo deklaraciok
//**************************************************************

// memoria keres utan 1-be irodik, ha megtortent a kert ram muvelet
reg				ram_read_ready	 	= 0;
reg				ram_write_ready 	= 0;
reg				layer0_ready	 	= 0;
reg				layer1_ready	 	= 0;
reg				layer2_ready	 	= 0;
reg				layer3_ready	 	= 0;
reg				text_ready		 	= 0;
reg				ext_cgrom_ready 	= 0;

// memoria keres utan invertalodik, ha megtortent a kert ram muvlet
reg				pixel_read_ready 	= 1;
reg				pixel_write_ready	= 1;


// RAM muveleteknel a prioritas enkoder az irast vagy az olvasas kerest
// is jelzi 0-val vagy 1-el
parameter		read 	= 0;
parameter		write	= 1;

parameter		cpu_ram_read_req  	 =  0;  // mem_req[0]
parameter		cpu_ram_write_req 	 =  1;  // mem_req[1]
parameter		text_mem_req			 =  2;  // mem_req[2]
parameter		ext_cgrom_mem_req		 =  3;  // mem_req[3]
parameter		layer0_mem_req 		 =  4;  // mem_req[4]
parameter		layer1_mem_req 		 =  5;  // mem_req[5]
parameter		layer2_mem_req 		 =  6;  // mem_req[6]
parameter		layer3_mem_req 		 =  7;  // mem_req[7]
parameter		pixel_read_mem_req 	 =  8;  // mem_req[8]
parameter		pixel_write_mem_req	 =  9;  // mem_req[9]
parameter		capture_write_mem_req = 10;  // mem_req[10]


parameter		cpu_bram_read_req  		 = 0;  // barm_mem_req[0]
parameter		cpu_bram_write_req 		 = 1;  // barm_mem_req[1]
parameter		pixel_read_bram_mem_req	 = 2;	// barm_mem_req[2]
parameter		pixel_write_bram_mem_req = 3;	// barm_mem_req[3]


reg	 [3:0]	bram_mem_req	 = 0;		// Block RAM hozzaferes igeny jelzes
													// b3 b2 b1 b0 <- mem_req 			
													//  |  |  |  | 
													//  |  |  |   --> cpu_bram_read_req
													//  |  |   -----> cpu_bram_write_req
													//  |   --------> point_bram_mem_req
													//   -----------> plot_bram_mem_req
													
reg	[10:0]	mem_req			 = 0;		// RAM hozzaferes igeny jelzes
													// b10 b9 b8 b7 b6 b5 b4 b3 b2 b1 b0 <- mem_req 			
													//  | |	 |  |  |  |  |  |  |  |  | 
													//  |	 |	 |  |  |  |  |  |  |  |   --> cpu_ram_read_req
													//  |	 |  |  |  |  |  |  |  |   -----> cpu_ram_write_req
													//  |	 |  |  |  |  |  |  |   --------> text_mem_req
													//  |	 |  |  |  |  |  |   -----------> ext_cgrom_mem_req
   												//  |	 |  |  |  |  |   --------------> layer0_mem_req
													//  |	 |  |  |  |   -----------------> layer1_mem_req
													//  |	 |  |  |   --------------------> layer2_mem_req
													//  |	 |  |   -----------------------> layer3_mem_req
													//  |	 |   --------------------------> pixel_read_mem_req
													//  |   -----------------------------> pixel_write_mem_req
													//   --------------------------------> capture_write_mem_req

reg			bram_mem_mode = 0; // 0 = olvasas, 1 = iras
reg			mem_mode		  = 0; // 0 = olvasas, 1 = iras


reg	[2:0] bram_mem_target = 0;	//  0 = semmi
											//  1 = CPU olvasas
											//  2 = CPU iras
											//	 3 = pixel olvasas
											//  4 = pixel iras 
										
reg	[3:0] mem_target = 0; 	//  0 = semmi
										//  1 = CPU olvasas
										//  2 = CPU iras
										//	 3 = text_layer olvasas
										//  4 = ext_cgrom olvasas
										//  5 = layer0 olvasas
										//  6 = layer1 olvasas
										//  7 = layer2 olvasas
										//  8 = layer3 olvasas
										//  9 = pixel olvasas
										// 10 = pixel iras
										// 11 = screen capture iras
								
wire bm_mode; 				// 0 = olvasas, 1 = iras
wire m_mode; 				// 0 = olvasas, 1 = iras

wire	[3:0]	bram_mem_req_target; // Block ram memoria hozzaferes prioritasdekoderenek a kimenete
											//  0 = semmi
											//  1 = CPU olvas
											//  2 = CPU ir
											//	 3 = pixel olvasas
											//  4 = pixel iras

wire	[3:0]	mem_req_target; 	// Memoria hozzaferes prioritasdekoderenek a kimenete
										//  0 = semmi
										//  1 = CPU olvas
										//  2 = CPU ir
										//	 3 = text_layer olvasas
										//  4 = ext_cgrom olvasas
										//  5 = layer0 olvasas
										//  6 = layer1 olvasas
										//  7 = layer2 olvasas
										//  8 = layer3 olvasas
										//  9 = pixel olvasas
										// 10 = pixel iras
										// 11 = screen capture iras
								
mem_prioritas_encoder PRIENC1( 
										 .input_memreq ( mem_req ), 
										 .out				( mem_req_target ),
										 .mem_mode 		( m_mode ),
										 .cpu_ready_mode ( ram_pri )
  									  );
BRAM_mem_prioritas_encoder PRIENC2(
												.input_memreq ( bram_mem_req ) ,
												.out ( bram_mem_req_target ), 			
												.mem_mode ( bm_mode )		
											  );

reg char_blink_preset	= 0; // 1 clk ideig 1 ha a char_blink_rate reg irva lett
reg graph_blink_preset	= 0; // 1 clk ideig 1 ha a grapf_blink_rate reg irva lett

lcd_sync		SYNC1(
						.clk ( clk ),
						.LCD_CP ( LCD_CP ),
						.LCD_LOAD ( LCD_LOAD ),
						.LCD_FRAME ( LCD_FRAME ), 
						.frame_start ( frame_start ),
						.lcd_cp_elott ( lcd_cp_elott ),
						.char_blink_bit ( char_blink_bit ),
						.char_blink_rate ( char_blink_rate ),
						.char_blink_preset ( char_blink_preset ),
						.graph_blink_rate ( graph_blink_rate ),
						.graph_blink_preset ( char_blink_preset ),
						.graph_blink_bit ( graph_blink_bit ),

						.lcd_x_ct ( lcd_x_ct ),
						.lcd_y_ct ( lcd_y_ct ),
						.lcd_x_ct_max ( lcd_x_ct_max ),
						.lcd_y_ct_max ( lcd_y_ct_max ),
						.refress_rate ( refress_rate )
						);				




// A 4 x 2 bit-es keppont adatok alapjan a szurke arnyalatoknak
// megfelelo lcd data kimenetet allitja elo.
wire	[3:0]	lookup_out;
lookup_table	LK1( .clk(clk), 
						  .cp_enable( lcd_cp_elott ), 
						  .frame_enable( frame_start ), 
						  .lcd_grayscale( lcd_data_puffer ), 
						  .lcd_out_data( lookup_out )
						);

reg	[6:0]	sprite_x_ct = 0;
reg	[7:0]	sprite_y_ct = 0;

reg			sprite0_start	= 0;
reg 	[8:0]	sprite0_x_pos 	= 0;
reg	[7:0]	sprite0_y_pos 	= 0;
reg	[6:0]	sprite0_width	= 17;
reg	[7:0]	sprite0_height = 73;
reg 	[8:0]	cpu_sprite0_x_pos  = 0;
reg	[7:0]	cpu_sprite0_y_pos  = 0;
reg			sprite0_pos_preset = 0;
wire	[7:0]	sprite0_data;
wire	[3:0]	sprite0_attr;
reg			sprite0_attr_en = 0;
wire			sprite0_ready;

reg			sprite1_start	= 0;
reg 	[8:0]	sprite1_x_pos 	= 0;
reg	[7:0]	sprite1_y_pos 	= 0;
reg	[6:0]	sprite1_width	= 17;
reg	[7:0]	sprite1_height = 73;
reg 	[8:0]	cpu_sprite1_x_pos  = 100;
reg	[7:0]	cpu_sprite1_y_pos  = 0;
reg			sprite1_pos_preset = 0;
wire	[7:0]	sprite1_data;
wire	[3:0]	sprite1_attr;
reg			sprite1_attr_en = 0;
wire			sprite1_ready;

reg			sprite2_start	= 0;
reg 	[8:0]	sprite2_x_pos 	= 0;
reg	[7:0]	sprite2_y_pos 	= 100;
reg	[6:0]	sprite2_width	= 17;
reg	[7:0]	sprite2_height = 73;
reg 	[8:0]	cpu_sprite2_x_pos  = 0;
reg	[7:0]	cpu_sprite2_y_pos  = 0;
reg			sprite2_pos_preset = 0;
wire	[7:0]	sprite2_data;
wire	[3:0]	sprite2_attr;
reg			sprite2_attr_en = 0;
wire			sprite2_ready;



Sprite	SPRITE0( .clk ( clk ),
						.start ( sprite0_start ),
						.x_pos ( sprite0_x_pos ),
						.y_pos ( sprite0_y_pos ),
						.width ( sprite0_width ),
						.height ( sprite0_height ),
						.x_ct ( sprite_x_ct ),
						.y_ct ( sprite_y_ct ),
						.ram_addr ( sprite0_addr ),
						.ram_data ( sprite0_data_out ),
						.ram_clk ( sprite0_clk ),
						.sprite_data ( sprite0_data ),
						.sprite_attr ( sprite0_attr ),
						.sprite_attr_en ( sprite0_attr_en ),
						.ready ( sprite0_ready )
						);

Sprite	SPRITE1( .clk ( clk ),
						.start ( sprite1_start ),
						.x_pos ( sprite1_x_pos ),
						.y_pos ( sprite1_y_pos ),
						.width ( sprite1_width ),
						.height ( sprite1_height ),
						.x_ct ( sprite_x_ct ),
						.y_ct ( sprite_y_ct ),
						.ram_addr ( sprite1_addr ),
						.ram_data ( sprite1_data_out ),
						.ram_clk ( sprite1_clk ),
						.sprite_data ( sprite1_data ),
						.sprite_attr ( sprite1_attr ),
						.sprite_attr_en ( sprite1_attr_en ),
						.ready ( sprite1_ready )
						);

Sprite	SPRITE2( .clk ( clk ),
						.start ( sprite2_start ),
						.x_pos ( sprite2_x_pos ),
						.y_pos ( sprite2_y_pos ),
						.width ( sprite2_width ),
						.height ( sprite2_height ),
						.x_ct ( sprite_x_ct ),
						.y_ct ( sprite_y_ct ),
						.ram_addr ( sprite2_addr ),
						.ram_data ( sprite2_data_out ),
						.ram_clk ( sprite2_clk ),
						.sprite_data ( sprite2_data ),
						.sprite_attr ( sprite2_attr ),
						.sprite_attr_en ( sprite2_attr_en ),
						.ready ( sprite2_ready )
						);


Pixel_point_plot PIX_PP( .clk ( clk ),              									//  1 bit input
								 .plot_stop ( plot_stop ),										//  1 bit input
								 .cpu_plot_start ( cpu_plot_start ),    					//  1 bit input
								 .cpu_point_start ( cpu_point_start ),   					//  1 bit input
								 .line_draw_plot_start ( line_draw_plot_start ),		//  1 bit input
								 .block_plot_start ( block_plot_start ),					//  1 bit input
								 .block_point_start ( block_point_start ),				//  1 bit input
								 .ext_x ( x ),				  										//  9 bit input
								 .ext_y ( y ),				  										//  8 bit input
								 .ext_layer_select ( layer_select ),  						//  3 bit input
								 .ext_pixel_bp ( pixel_bp ),		  							//  1 bit input
								 .ext_plot_pixel_bright ( plot_pixel_bright ),			//  2 bit input
								 .ext_plot_pixel_attr ( plot_attr ),						//  1 bit input
								 .sprite_attr_write_en ( sprite_attr_write_en ),	//  1 bit input
								 .line_draw_x ( line_draw_x_out ),							//  9 bit input
								 .line_draw_y ( line_draw_y_out ),							//  8 bit input
								 .layer0_start_addr ( layer0_start_addr ), 				// 16 bit input
								 .layer1_start_addr ( layer1_start_addr ), 				// 16 bit input
								 .layer2_start_addr ( layer2_start_addr ), 				// 16 bit input
								 .layer3_start_addr ( layer3_start_addr ), 				// 16 bit input
								 .layerx_start_addr ( layerx_start_addr ), 				// 16 bit input
								 .sprite0_width ( sprite0_width ),							//  6 bit input
								 .sprite0_height ( sprite0_height ),	 					//  8 bit input
								 .sprite1_width ( sprite1_width ),							//  6 bit input
								 .sprite1_height ( sprite1_height ),	 					//  8 bit input
								 .sprite2_width ( sprite2_width ),							//  6 bit input
								 .sprite2_height ( sprite2_height ),	 					//  8 bit input
								 .block_x_in ( block_x_out ),									//  9 bit input
								 .block_y_in ( block_y_out ),									//  8 bit input
								 .block_pixel_bp ( block_pixel_bp ),					   //  1 bit input
								 .block_plot_pixel_bright ( block_plot_pixel_bright),	//	 2 bit input
								 .block_layer_select ( block_layer_select ),			   //  3 bit input
								 .ram_ready( pixel_ram_ready ),								//  1 bit input
								 .pixel_read_data ( pixel_read_data ),						//  8 bit input
								 .pixel_write_mode ( pixel_write_mode ),					//  8 bit input
								 .circle_x ( circle_x_out ),									//  9 bit input
								 .circle_y ( circle_y_out ),									//  8 bit input
								 .circle_plot_start ( circle_plot_start ),				//  1 bit input
								 .pixel_dashed_pattern ( pixel_dashed_pattern ), 		//  1 bit input
								 
								 .read_mem_req ( pixel_read_req ),						//  1 bit output
								 .write_mem_req ( pixel_write_req ),					//  1 bit output
								 .bram_read_mem_req ( bram_pixel_read_req ),			//  1 bit output
								 .bram_write_mem_req ( bram_pixel_write_req ),		//  1 bit output
								 .pixel_addr ( pixel_addr ),								// 17 bit output
								 .point_pixel_bright ( point_pixel_bright ),			//  2 bit output
								 .pixel_point_attr ( point_attr ),						//  1 bit output
								 .pixel_write_data ( pixel_write_data ),				//  8 bit output
								 .plot_ready ( plot_ready ),								//  1 bit output
								 .ready ( plot_point_ready ),								//  1 bit output
								 .x ( pixel_out_x ),											//  9 bit output
								 .y ( pixel_out_y )											//  8 bit output
    );



//************************
//**  I/O modulok
//************************

reg	[7:0]	p0_out	= 0;
reg	[7:0]	p0_dir	= 0;
//reg	[7:0]	p0_alt	= 0;
reg	[7:0]	p1_out	= 0;
reg	[7:0]	p1_dir	= 0;
//reg	[7:0]	p1_alt	= 0;
reg	[7:0]	p2_out	= 0;
reg	[7:0]	p2_dir	= 0;
reg	[7:0]	p2_alt	= 0;
reg	[7:0]	p3_out	= 0;
reg	[7:0]	p3_dir	= 0;
reg	[2:0]	p3_alt	= 0;

reg	[7:0]	p2_reg	= 0;
reg	[7:0]	p3_reg	= 0;

reg	[3:0] enc_type = 0;
reg	[3:0]	enc_mode = 0;
reg	[3:0]	enc_dir	= 0;
reg	[7:0]	set_data = 0;
reg			set_enc0 = 0;
reg			set_enc1 = 0;
reg			set_enc2 = 0;
reg			set_enc3 = 0;
wire	[7:0]	enc0_data;
wire	[7:0]	enc1_data;
wire	[7:0]	enc2_data;
wire	[7:0]	enc3_data;

quad ENC0 (.clk( clk ), .quadA( PORT0[0] ), .quadB( PORT0[1] ), .count( enc0_data ), .set( set_enc0 ), .set_data( set_data ), .enc_mode( enc_mode[0] ), .enc_dir( enc_dir[0] ), .enc_type( enc_type[0] )); 
quad ENC1 (.clk( clk ), .quadA( PORT0[2] ), .quadB( PORT0[3] ), .count( enc1_data ), .set( set_enc1 ), .set_data( set_data ), .enc_mode( enc_mode[1] ), .enc_dir( enc_dir[1] ), .enc_type( enc_type[1] )); 
quad ENC2 (.clk( clk ), .quadA( PORT0[4] ), .quadB( PORT0[5] ), .count( enc2_data ), .set( set_enc2 ), .set_data( set_data ), .enc_mode( enc_mode[2] ), .enc_dir( enc_dir[2] ), .enc_type( enc_type[2] )); 
quad ENC3 (.clk( clk ), .quadA( PORT0[6] ), .quadB( PORT0[7] ), .count( enc3_data ), .set( set_enc3 ), .set_data( set_data ), .enc_mode( enc_mode[3] ), .enc_dir( enc_dir[3] ), .enc_type( enc_type[3] )); 

reg	[7:0]	 pwm8_ct 		= 0;
reg	[7:0]  pwm8_div		= 0;
reg			 pwm8_count_en = 0;

reg	[7:0]	 pwm8_0_in 		= 0;
wire			 pwm8_0_out;
reg	[7:0]	 pwm8_1_in 		= 0;
wire			 pwm8_1_out;
reg	[7:0]	 pwm8_2_in 		= 0;
wire			 pwm8_2_out;

pwm_8 PWM8_0 ( .clk( clk ), .pwm_in( pwm8_0_in ), .pwm_out( pwm8_0_out ), .pwm_count_en( pwm8_count_en ) );
pwm_8 PWM8_1 ( .clk( clk ), .pwm_in( pwm8_1_in ), .pwm_out( pwm8_1_out ), .pwm_count_en( pwm8_count_en ) );
pwm_8 PWM8_2 ( .clk( clk ), .pwm_in( pwm8_2_in ), .pwm_out( pwm8_2_out ), .pwm_count_en( pwm8_count_en ) );

reg	[11:0] pwm_buzzer_ct 		= 0;
reg	 [7:0] pwm_buzzer_div		= 0;
reg			 pwm_buzzer_count_en = 0;

reg	 [7:0] pwm_buzzer_in 		= 0;
wire	 	    pwm_buzzer_out;

pwm_8 PWM_BUZZER ( .clk( clk ), .pwm_in( pwm_buzzer_in ), .pwm_out( pwm_buzzer_out ), .pwm_count_en( pwm_buzzer_count_en ) );


reg	[3:0]	 pwm12_ct 		 = 0;
reg	[3:0]  pwm12_div		 = 0;
reg			 pwm12_count_en = 0;

reg	[11:0] pwm12_0_in 	 = 0;
wire			 pwm12_0_out;
reg	[11:0] pwm12_1_in 	 = 0;
wire			 pwm12_1_out;
reg	[11:0] pwm12_2_in 	 = 0;
wire			 pwm12_2_out;
reg	[11:0] pwm12_3_in 	 = 0;
wire			 pwm12_3_out;

pwm_12 PWM12_0 ( .clk( clk ), .pwm_in( pwm12_0_in ), .pwm_out( pwm12_0_out ), .pwm_count_en( pwm12_count_en ) );
pwm_12 PWM12_1 ( .clk( clk ), .pwm_in( pwm12_1_in ), .pwm_out( pwm12_1_out ), .pwm_count_en( pwm12_count_en ) );
pwm_12 PWM12_2 ( .clk( clk ), .pwm_in( pwm12_2_in ), .pwm_out( pwm12_2_out ), .pwm_count_en( pwm12_count_en ) );
pwm_12 PWM12_3 ( .clk( clk ), .pwm_in( pwm12_3_in ), .pwm_out( pwm12_3_out ), .pwm_count_en( pwm12_count_en ) );


// SCOPE

reg	 [7:0]		trigger_level	= 128;
wire	[14:0]		trigger_addr;
reg	 [3:0]		trigger_mode	= 0;
reg					dig_mode			= 0;
reg	 [7:0]		dig_mask			= 0;
wire	 [2:0]		scope_status;
reg	[23:0]		time_div 		= 1000;
reg					trigger_en	 	= 0;
reg	[15:0]		sample_len		= 0;
reg					sample_ct_en	= 0;
wire	[14:0]		scope_write_addr;
reg					write_en			= 0;
reg					write_gate2		= 0;
reg	 [3:0]		hyst_level		= 2;
reg					adc_seq			= 0;
reg					scope_stop		= 0;
wire					scope_ready;
reg	[1:0]			scope_ready_edge = 0;
reg					scope_irq_en	= 0;
reg					scope_irq		= 1; // Ha vege a tarolasnak akkor scope_status[2] ( write_gate ) 
												  // lefutto ele torli
												  // A nIRQ kimenetere kerul, de csak akkor ha a
												  // nCPU_CE jel logikai "H" szintu es a scope_irq_en = 1.

Scope 	SCOPE(.clk( scope_clk ),						// 1 bit in
					.trigger_en( trigger_en ),				// 1bit in
					.trigger_level( trigger_level ),		// 8 bit in
					.trigger_mode( trigger_mode ),		// 4 bit in
					.dig_mode( dig_mode ),					// 1 bit in
					.dig_mask ( dig_mask ),					// 8 bit in
					.hyst_level( hyst_level ),				// 4 bit in
					.sample_len( sample_len ), 			// 15 bit in
					.sample_ct_en ( sample_ct_en ), 		// 1 bit in
					.write_en( write_en ),					// 1 bit in
					.write_gate2( write_gate2 ),			// 1 bit in
					.time_div( time_div ),					// 12 bit in
					.adc_data( PORT1 ),						// 8 bit in
					.ext_trigger( PORT3[7] ),				// 1 bit in
					.adc_seq( adc_seq ),						// 1 bit in
					.scope_stop( scope_stop ),				// 1 bit in
					
					.trigger_addr( trigger_addr ),	// 15 bit out
					.scope_status( scope_status ),	// 2 bit out
					.ram_addr( store_addr ),			// 12 bit out
					.scope_write_addr( scope_write_addr ), // 14 bit out
					.ram_data( store_write_data ),	// 32 bit out
					.ram_clk( store_clk ),				// 1 bit out
					.ready( scope_ready )				// 1 bit out
					);




// DS2401 sorozatszam, nelkule nem mukodik az LCD DATA kimenet :-)
//
		//parameter SID = 48'h001458C0C6;  // Legelso fullos panel
		//parameter SID = 48'h001458BE42;  // Horvath Jani panel
parameter SID = 40'h1458BE42;  // Horvath Jani panel
reg					one_wire_reset = 1;	// 1 wire reset
wire 	[39:0]		DS2401_serial_num;	// 40 bit serial number
wire					one_wire_crc_ok;		// read ok
reg					sid_ok 			= 1;  // 1 ha sikeresen beolvasta a helyes sorozatszamot
		//wire 	[47:0]		DS2401_serial_num;	// 48 bit serial number
		//wire					data_valid;
		//reg	[2:0]			delay	= 0;

onewire_iface DS2401( .sys_clk ( clk ),
							 .sys_reset ( one_wire_reset ), 
							 .dq ( DQ ), 
							 .data (), 
							 .data_valid (), 
							 .crc_ok ( one_wire_crc_ok ), 
							 .sn_data ( DS2401_serial_num )
							);

always @ ( posedge clk ) begin
	// Az lcd_y_ct_max csak a bekapcsolasi kesleltetes miatt tettem bele,
	// igy az Dallas chip-et csak ez utan olvassa
	if ( sid_ok == 0 && lcd_y_ct_max == 1 ) begin
		one_wire_reset <= 0; // Olvasas inditas
	end
		
	sid_ok <= 1; // Ha kell a DS2401 chip, akkor ez a sor nem kell !
	
	if ( one_wire_crc_ok == 1 ) begin
		if ( DS2401_serial_num == SID ) sid_ok <= 1; else one_wire_reset <= 0;
	end
end



/***********************************************************\
* 	A belso 50MHz - es orajel eloallitasa a 100 MHz - bol    *
*  az FPGA-n beluli DLL alkalmazasaval.                     *                                           
\***********************************************************/

/*	IBUFG	ibosc(.I(CLK_100MHz), .O(ickosc));
	CLKDLLHF #(
		.STARTUP_WAIT("TRUE"),
		.CLKDV_DIVIDE(16),		// 1.5 eseten 66MHz lesz az orajel :-)
		.DUTY_CYCLE_CORRECTION("FALSE")
	) dll_int (
		.CLKIN(ickosc),
		.CLKFB(CLK100),
		.CLK0(ck100),
		.CLKDV(ck50)
	);
	BUFG ob100(.I(ck100), .O(CLK100));
	BUFG  ob50(.I(ck50), .O(clk));
*/


assign clk = CLK_100MHz;

BUFG  clk_x( .I(PORT3[5]), .O(scope_clk));

//reg clk_div = 0;
//always @ ( posedge CLK_100MHz ) begin
//	clk_div <= clk_div + 1;
//end
//assign clk = clk_div;



always @ ( posedge clk ) begin

CLK_OUT <= CLK_OUT + 1;

	/********************************************************************\
	* 	Eldetektalasok                                                    *
	* 	                                                                  *
	* 	00 = "L" szint, 01 = Felfuto el, 11 = "H" szint, 10 = Lefuto el   *
	* 	                                                                  *
	\********************************************************************/

	// CPU RD jel az eldetektalashoz egy 2bit-es shiftregiszterbe
	ncpu_rd_edge[0] <= nCPU_RD;
	ncpu_rd_edge[1] <= ncpu_rd_edge[0];

	// CPU WR jel az eldetektalashoz a 2bit-es shiftregiszterbe
	ncpu_wr_edge[0] <= nCPU_WR;
	ncpu_wr_edge[1] <= ncpu_wr_edge[0];
	
	// A plot_point_ready jel az eldetektalashoz egy 2bit-es shiftregiszterbe
	plot_ready_edge[0] <= plot_ready;
	plot_ready_edge[1] <= plot_ready_edge[0];
	
	//------------------------------------------------------------------
	// Csak az egyik RAM van engedelyezve
	nRAM_CE0 = 0;	
	//nRAM_CE1 = 1;
	
end

// Pixel muvelet kesz jel meghajtasa
assign pixel_ram_ready = pixel_read_ready | pixel_write_ready;
						
// RAM READY jel meghajtas						
//assign CPU_READY = ram_read_ready & ram_write_ready & bram_write_ready & bram_read_ready;

// BUSY jel meghajtas						
//assign CPU_BUSY  = !plot_point_ready | !line_draw_ready | !block_ready | !circle_ready | screen_capture_start;

// A pixel modul szaggatott vonal rajzolasahoz a minta
assign pixel_dashed_pattern = dashed_pattern[ pattern_pointer[3:0] ];

// RAM adatbusz meghajtasa a ram_write_data regiszterbol 
// ha a WE es a CE0 aktiv "L" szintu kulonben (TS)
// A WE es a CE0 labak helyett a ramdbe regiszter van hasznalva
// az egyseges kimeneti idozitesek miatt!
// Minden ram-ba irando adatot a ram_write_data regiszterbe kell tolteni.

assign RAM_DATA = ( rambde == 0 /*!nRAM_WE && !nRAM_CE0*/ ) ? ram_write_data : 16'hzz;


//------------------------------------------------------------------
// A belso regiszterek kikuldese CPU fele meno adatbuszra ha az RD jel 
// aktiv "L" szintu es az WR jel "H" szintu kulonbenm (TS)
//------------------------------------------------------------------
assign CPU_DATA = ( !nCPU_CE && !nCPU_RD && nCPU_WR && CPU_RS == 1 ) ? lcd_reg_select:
						( !nCPU_CE && !nCPU_RD && nCPU_WR && CPU_RS == 0 ) ? read_xxx:
						8'hzz;


// Block ram-ok szelektalasa a bram_addr[14:11] erteketol fuggoen

assign s_ram_en[0] 		= ( bram_addr[14:11] ==  0 ) ? 1 : 0;
assign s_ram_en[1] 		= ( bram_addr[14:11] ==  1 ) ? 1 : 0;
assign s_ram_en[2] 		= ( bram_addr[14:11] ==  2 ) ? 1 : 0;
assign s_ram_en[3] 		= ( bram_addr[14:11] ==  3 ) ? 1 : 0;
assign s_ram_en[4] 		= ( bram_addr[14:11] ==  4 ) ? 1 : 0;
assign s_ram_en[5] 		= ( bram_addr[14:11] ==  5 ) ? 1 : 0;
assign s_ram_en[6] 		= ( bram_addr[14:11] ==  6 ) ? 1 : 0;
assign s_ram_en[7] 		= ( bram_addr[14:11] ==  7 ) ? 1 : 0;
assign s_ram_en[8] 		= ( bram_addr[14:11] ==  8 ) ? 1 : 0;
assign s_ram_en[9] 		= ( bram_addr[14:11] ==  9 ) ? 1 : 0;
assign bram_sprite0_en 	= ( bram_addr[14:11] == 10 ) ? 1 : 0;
assign bram_sprite1_en 	= ( bram_addr[14:11] == 11 ) ? 1 : 0;
assign bram_sprite2_en 	= ( bram_addr[14:11] == 12 ) ? 1 : 0;
assign bram_cgrom0_en  	= ( bram_addr[14:11] == 13 ) ? 1 : 0;
assign bram_cgrom1_en  	= ( bram_addr[14:11] == 14 ) ? 1 : 0;
assign bram_cgrom2_en  	= ( bram_addr[14:11] == 15 ) ? 1 : 0;

 
// Block ram adat szelektalasa a bram_addr[14:11] erteketol fuggoen
assign bram_read_data = ( bram_addr[14:11] ==  0 ) ? s_data_out0:
								( bram_addr[14:11] ==  1 ) ? s_data_out1:
								( bram_addr[14:11] ==  2 ) ? s_data_out2:
								( bram_addr[14:11] ==  3 ) ? s_data_out3:
								( bram_addr[14:11] ==  4 ) ? s_data_out4:
								( bram_addr[14:11] ==  5 ) ? s_data_out5:
								( bram_addr[14:11] ==  6 ) ? s_data_out6:
								( bram_addr[14:11] ==  7 ) ? s_data_out7:
								( bram_addr[14:11] ==  8 ) ? s_data_out8:
								( bram_addr[14:11] ==  9 ) ? s_data_out9:
								( bram_addr[14:11] == 10 ) ? bram_sprite0_data_out :
								( bram_addr[14:11] == 11 ) ? bram_sprite1_data_out :
								( bram_addr[14:11] == 12 ) ? bram_sprite2_data_out : 
								( bram_addr[14:11] == 13 ) ? bram_cgrom0_data_out : 
								( bram_addr[14:11] == 14 ) ? bram_cgrom1_data_out : 
								( bram_addr[14:11] == 15 ) ? bram_cgrom2_data_out : 0;
								

//********** I/O *********************

// PORT0
assign PORT0[0] = ( p0_dir[0] == 1 ) ? p0_out[0]  :  1'hz;
assign PORT0[1] = ( p0_dir[1] == 1 ) ? p0_out[1]  :  1'hz;
assign PORT0[2] = ( p0_dir[2] == 1 ) ? p0_out[2]  :  1'hz;
assign PORT0[3] = ( p0_dir[3] == 1 ) ? p0_out[3]  :  1'hz;
assign PORT0[4] = ( p0_dir[4] == 1 ) ? p0_out[4]  :  1'hz;
assign PORT0[5] = ( p0_dir[5] == 1 ) ? p0_out[5]  :  1'hz;
assign PORT0[6] = ( p0_dir[6] == 1 ) ? p0_out[6]  :  1'hz;
assign PORT0[7] = ( p0_dir[7] == 1 ) ? p0_out[7]  :  1'hz;

// PORT1
assign PORT1[0] = ( p1_dir[0] == 1 ) ? p1_out[0]  :  1'hz;
assign PORT1[1] = ( p1_dir[1] == 1 ) ? p1_out[1]  :  1'hz;
assign PORT1[2] = ( p1_dir[2] == 1 ) ? p1_out[2]  :  1'hz;
assign PORT1[3] = ( p1_dir[3] == 1 ) ? p1_out[3]  :  1'hz;
assign PORT1[4] = ( p1_dir[4] == 1 ) ? p1_out[4]  :  1'hz;
assign PORT1[5] = ( p1_dir[5] == 1 ) ? p1_out[5]  :  1'hz;
assign PORT1[6] = ( p1_dir[6] == 1 ) ? p1_out[6]  :  1'hz;
assign PORT1[7] = ( p1_dir[7] == 1 ) ? p1_out[7]  :  1'hz;

// PORT2
assign PORT2[0] = ( p2_dir[0] == 1 ) ? p2_reg[0] : 1'hz;
assign PORT2[1] = ( p2_dir[1] == 1 ) ? p2_reg[1] : 1'hz;
assign PORT2[2] = ( p2_dir[2] == 1 ) ? p2_reg[2] : 1'hz;
assign PORT2[3] = ( p2_dir[3] == 1 ) ? p2_reg[3] : 1'hz;
assign PORT2[4] = ( p2_dir[4] == 1 ) ? p2_reg[4] : 1'hz;
assign PORT2[5] = ( p2_dir[5] == 1 ) ? p2_reg[5] : 1'hz;
assign PORT2[6] = ( p2_dir[6] == 1 ) ? p2_reg[6] : 1'hz;
assign PORT2[7] = ( p2_dir[7] == 1 ) ? p2_reg[7] : 1'hz;

// PORT3
assign PORT3[0] = ( p3_dir[0] == 1 ) ? p3_reg[0] : 1'hz;
assign PORT3[1] = ( p3_dir[1] == 1 ) ? p3_reg[1] : 1'hz;
assign PORT3[2] = ( p3_dir[2] == 1 ) ? p3_reg[2] : 1'hz;
assign PORT3[3] = ( p3_dir[3] == 1 ) ? p3_reg[3] : 1'hz;
assign PORT3[4] = ( p3_dir[4] == 1 ) ? p3_reg[4] : 1'hz;
assign PORT3[5] = ( p3_dir[5] == 1 ) ? p3_reg[5] : 1'hz;
assign PORT3[6] = ( p3_dir[6] == 1 ) ? p3_reg[6] : 1'hz;
assign PORT3[7] = ( p3_dir[7] == 1 ) ? p3_reg[7] : 1'hz;

always @ ( posedge clk ) begin

// PORT2
if ( p2_alt[0] == 0 ) p2_reg[0] <= p2_out[0]; else p2_reg[0] <= pwm8_0_out;
if ( p2_alt[1] == 0 ) p2_reg[1] <= p2_out[1]; else p2_reg[1] <= pwm8_1_out;
if ( p2_alt[2] == 0 ) p2_reg[2] <= p2_out[2]; else p2_reg[2] <= pwm8_2_out;
if ( p2_alt[3] == 0 ) p2_reg[3] <= p2_out[3]; else p2_reg[3] <= pwm_buzzer_out;
if ( p2_alt[4] == 0 ) p2_reg[4] <= p2_out[4]; else p2_reg[4] <= pwm12_0_out;
if ( p2_alt[5] == 0 ) p2_reg[5] <= p2_out[5]; else p2_reg[5] <= pwm12_1_out;
if ( p2_alt[6] == 0 ) p2_reg[6] <= p2_out[6]; else p2_reg[6] <= pwm12_2_out;
if ( p2_alt[7] == 0 ) p2_reg[7] <= p2_out[7]; else p2_reg[7] <= pwm12_3_out;

// PORT3
if ( p3_alt[0] == 0 ) p3_reg[0] <= p3_out[0]; else p3_reg[0] <= scope_status[0];
if ( p3_alt[1] == 0 ) p3_reg[1] <= p3_out[1]; else p3_reg[1] <= scope_status[1];
if ( p3_alt[2] == 0 ) p3_reg[2] <= p3_out[2]; else p3_reg[2] <= scope_status[2];
p3_reg[3] <= p3_out[3]; 
p3_reg[4] <= p3_out[4]; 
p3_reg[5] <= p3_out[5];
p3_reg[6] <= p3_out[6];
p3_reg[7] <= p3_out[7];


// RAM READY jel meghajtas						
	CPU_READY <= ram_read_ready & ram_write_ready & bram_write_ready & bram_read_ready;

// BUSY jel meghajtas						
	CPU_BUSY  <= !plot_point_ready | !line_draw_ready | !block_ready | !circle_ready | screen_capture_start;

// SCOPE IRQ kezeles
	nIRQ <= ( nCPU_CE == 1 && scope_irq_en == 1 ) ? scope_irq : 1;


	scope_ready_edge[0] <= scope_ready;
	scope_ready_edge[1] <= scope_ready_edge[0];
	//if ( scope_ready == 1 ) scope_irq <= 0;
	if ( scope_ready_edge[1] != scope_ready_edge[0] ) scope_irq <= 0;

	// 8 bit-es PWM 0, 1, 2 eloosztas
	pwm8_count_en <= 0;
	if ( pwm8_ct == pwm8_div ) begin
		pwm8_count_en <= 1;
		pwm8_ct 		  <= 0;
	end
	else begin
		pwm8_ct <= pwm8_ct + 1;
	end

	// 12 bit-es PWM 4, 5, 6, 7 eloosztas
	pwm12_count_en <= 0;
	if ( pwm12_ct == pwm12_div ) begin
		pwm12_count_en <= 1;
		pwm12_ct 		<= 0;
	end
	else begin
		pwm12_ct <= pwm12_ct + 1;
	end


	// 8 bit-es PWM 3 eloosztas
	pwm_buzzer_count_en <= 0;
	if ( pwm_buzzer_ct[11:4] == pwm_buzzer_div ) begin
		pwm_buzzer_count_en <= 1;
		pwm_buzzer_ct 		  <= 0;
	end
	else begin
		pwm_buzzer_ct <= pwm_buzzer_ct + 1;
	end

	

	// CPU fele torteno olvasashoz a read_xxx regiszterbe a reg_select-tol fuggo adatok
	case ( lcd_reg_select )
		 0: read_xxx <= { 6'b000000, cpu_ram_address[17:16] };
		 1: read_xxx <= cpu_ram_address[15:8];
		 2: read_xxx <= cpu_ram_address[7:0]; 
		 3: if ( cpu_ram_address[17] == 0 )	read_xxx <= cpu_read_data; else read_xxx <= bram_read_data;
		 4: read_xxx <= lcd_enable;	
		 5: read_xxx <= { char_blink_rate[3:0] };	
		 6: read_xxx <= { layer0_blink_inv, layer0_blink_en, layer0_bp, layer0_bright };	
		 7: read_xxx <= layer0_start_hi;	
		 8: read_xxx <= layer0_start_lo;	
		 9: read_xxx <= { layer1_mask_en, layer1_blink_inv, layer1_blink_en, layer1_bp, layer1_bright };	
		10: read_xxx <= layer1_start_hi;	
		11: read_xxx <= layer1_start_lo;	
		12: read_xxx <= { layer2_mask_en, layer2_blink_inv, layer2_blink_en, layer2_bp, layer2_bright };	
		13: read_xxx <= layer2_start_hi;	
		14: read_xxx <= layer2_start_lo;	
		15: read_xxx <= { layer3_mask_en, layer3_blink_inv, layer3_blink_en, layer3_bp, layer3_bright };	
		16: read_xxx <= layer3_start_hi;	
		17: read_xxx <= layer3_start_lo;	
		18: read_xxx <= { layerx_bp, layerx_bright };	
		19: read_xxx <= layerx_start_addr[15:8];	
		20: read_xxx <= layerx_start_addr[7:0];	
		21: read_xxx <= text_mode;	
		22: read_xxx <= text_start_hi;	
		23: read_xxx <= text_start_lo;	
		24: read_xxx <= ext_cgrom_start_addr[8:1];	
		25: read_xxx <= ext_cgrom_start_addr[16:9];	
		26: read_xxx <= { y_auto_inc[3:0],x_auto_inc[3:0] };
		27: read_xxx <= dashed_pattern[15:8];
		28: read_xxx <= dashed_pattern[7:0];
		29: read_xxx <= pattern_pointer[3:0];
		30: read_xxx <= { function_select[3:0], pixel_write_mode[3:0] }; 
		31: read_xxx <= { 7'b0000000, x[8] };	
		32: read_xxx <= x[7:0];	
		33: read_xxx <= y[7:0];	
		34: read_xxx <= { 7'b0000000, x1[8] };	
		35: read_xxx <= x1[7:0];	
		36: read_xxx <= y1[7:0];	
		37: read_xxx <= { plot_point_ready, sprite_attr_write_en, layer_select[2:0], point_attr, point_pixel_bright[1:0] };	
		38: read_xxx <= { line_draw_ready, sprite_attr_write_en, layer_select[2:0], point_attr, point_pixel_bright[1:0] };
		39: read_xxx <= { circle_ready, sprite_attr_write_en, layer_select[2:0], point_attr, point_pixel_bright[1:0] };
		40: read_xxx <= { 3'b000, block_mode };
		41: read_xxx <= { 7'b0000000, block_width[8] };
		42: read_xxx <= block_width[7:0];
		43: read_xxx <= block_height[7:0];
		44: read_xxx <= { block_ready, 1'b0, target_layer[2:0], source_layer[2:0] };
		45: read_xxx <= { 7'b0000000, max_plot_ct[8] };
		46: read_xxx <= max_plot_ct[7:0];
	
		// Sprite
		60: read_xxx <= { 1'b0, sprite0_width[6:0] };
		61: read_xxx <= sprite0_height[7:0];
		62: read_xxx <= { 7'b0000000, cpu_sprite0_x_pos[8] };
		63: read_xxx <= cpu_sprite0_x_pos[7:0];
		64: read_xxx <= cpu_sprite0_y_pos[7:0];
		65: read_xxx <= { 1'b0, sprite1_width[6:0] };
		66: read_xxx <= sprite1_height[7:0];
		67: read_xxx <= { 7'b0000000, cpu_sprite1_x_pos[8] };
		68: read_xxx <= cpu_sprite1_x_pos[7:0];
		69: read_xxx <= cpu_sprite1_y_pos[7:0];
		70: read_xxx <= { 1'b0, sprite2_width[6:0] };
		71: read_xxx <= sprite2_height[7:0];
		72: read_xxx <= { 7'b0000000, cpu_sprite2_x_pos[8] };
		73: read_xxx <= cpu_sprite2_x_pos[7:0];
		74: read_xxx <= cpu_sprite2_y_pos[7:0];
		75: read_xxx <= { 2'b00, sprite_enable };
		
		// Port 0
	  128: read_xxx <= p0_out;
	  129: read_xxx <= PORT0;
	  130: read_xxx <= p0_dir;
	  //131: read_xxx <= p0_alt;
	  
		// Port 1
     132: read_xxx <= p1_out;
	  133: read_xxx <= PORT1;
	  134: read_xxx <= p1_dir;
	  //135: read_xxx <= p1_alt;
	  
		// Port 2
	  136: read_xxx <= p2_out;
	  137: read_xxx <= PORT2;
	  138: read_xxx <= p2_dir;
	  139: read_xxx <= p2_alt;
	  
		// Port 3
	  140: read_xxx <= p3_out;
	  141: read_xxx <= PORT3;
	  142: read_xxx <= p3_dir;
	  143: read_xxx <= p3_alt;
	  	  
		// Forgasjeladok
	  145: read_xxx <= enc0_data;
	  146: read_xxx <= enc1_data;
	  147: read_xxx <= enc2_data;
	  148: read_xxx <= enc3_data;
	  149: read_xxx <= { enc_dir, enc_mode };
	  150: read_xxx <= { 4'b0000, enc_type };
	  
	   // PWM
	  151: read_xxx <= pwm8_0_in;
	  152: read_xxx <= pwm8_1_in;
	  153: read_xxx <= pwm8_2_in;
	  154: read_xxx <= pwm8_div;

	  155: read_xxx <= pwm_buzzer_in;
	  156: read_xxx <= pwm_buzzer_div;

	  157: read_xxx <= pwm12_0_in[11:8];
	  158: read_xxx <= pwm12_0_in[7:0];
	  159: read_xxx <= pwm12_0_in[11:8];
	  160: read_xxx <= pwm12_0_in[7:0];
	  161: read_xxx <= pwm12_0_in[11:8];
	  162: read_xxx <= pwm12_0_in[7:0];
	  163: read_xxx <= pwm12_0_in[11:8];
	  164: read_xxx <= pwm12_0_in[7:0];
	  165: read_xxx <= pwm12_div[3:0];


		// Scope
	  200: read_xxx <= trigger_level;
	  201: read_xxx <= { hyst_level[3:0], trigger_mode[3:0] };
	  202: read_xxx <= trigger_addr[14:8];
	  203: read_xxx <= trigger_addr[7:0];
	  
	  204: read_xxx <= time_div[23:16];
	  205: read_xxx <= time_div[15:8];
	  206: read_xxx <= time_div[7:0];

	  207: read_xxx <= sample_len[15:8];
	  208: read_xxx <= sample_len[7:0];
	  209: read_xxx <= { scope_irq, scope_irq_en, dig_mode,  scope_stop, write_gate2, scope_status[2:0] };
	
	  210: 	begin 
					read_xxx <= scope_write_addr[14:8];
					set_data	<= scope_write_addr[7:0];
				end
	  211: read_xxx <= set_data;

	  212: read_xxx <= dig_mask;
					
  
		// DS chip
     //240: read_xxx <= DS2401_serial_num[47:40];
	  241: read_xxx <= DS2401_serial_num[39:32];
	  242: read_xxx <= DS2401_serial_num[31:24];
	  243: read_xxx <= DS2401_serial_num[23:16];
	  244: read_xxx <= DS2401_serial_num[15:8];
	  245: read_xxx <= DS2401_serial_num[7:0];
	  246: read_xxx <= {6'b00000, sid_ok, one_wire_crc_ok };
  
	  
	  // Egyeb
	  250: read_xxx <= ram_cur_step;
	  255: read_xxx <= { screen_capture_start, adc_seq, refress_rate[4:0], ram_pri };
	endcase

	// Pattern ponter leptetese minden plot utan
	if ( plot_ready_edge == 1 ) begin
		pattern_pointer <= pattern_pointer + 1;
		// A PLOT korlatozo szamlalo leptetese
		if ( plot_ct < max_plot_ct ) plot_ct <= plot_ct + 1;
	end

	// Az utoljra kiirt pixel koordinatajanak a beirasa a x, z regiszterbe
	if ( max_plot_ct != 0 && plot_ct >= max_plot_ct ) begin
   	plot_stop <= 1; 
		if ( plot_stop == 0 ) begin
			x <= pixel_out_x;
			y <= pixel_out_y;
		end
	end
	else begin
		plot_stop <= 0;
	end
	
	//********** 1 clk ido utan az iditojelek torlese **********
	
	if ( cpu_line_draw_start == 1 ) begin 
		cpu_line_draw_start	<= 0;
		// Gyorsabb vonalrajzolashoz a kezdes utan a start koordinatakba
		// beirom a celkoordinatakat. Igy a vegpontbol kiindulo ujabb vonal
		// rajzolasahoz nem kell a kezdopontot megadni.
		x <= x1;
		y <= y1;
	end

	if ( cpu_plot_start == 1 ) begin
		cpu_plot_start			<= 0;
		// Automatikus koordinata valtoztatas
		if ( x_auto_inc[3] == 0 ) x <= x + x_auto_inc[2:0]; else x <= x - x_auto_inc[2:0];
		if ( y_auto_inc[3] == 0 ) y <= y + y_auto_inc[2:0]; else y <= y - x_auto_inc[2:0];
	end

	// GPU indito impulzusok visszabillentese
	cpu_point_start 		<= 0;
	cpu_circle_start	   <= 0;
	cpu_block_start		<= 0;


	// Villigtatasi beallitas jelzes visszabillentese
	char_blink_preset  <= 0;
	graph_blink_preset <= 0;
	
	// Encoder beallitas jelzes visszabillentese
	set_enc0	<= 0;
	set_enc1	<= 0;
	set_enc2	<= 0;
	set_enc3	<= 0;

	// Scope modul jeleinek a visszabillentese
	//sample_ct_en <= 0;
	//trigger_en	 <= 0;
	//write_en		 <= 0;
	scope_stop	 <= 0;
	

	
	// *********************
	// *** CPU <--- FPGA ***
	// *********************
	// Ha az nCPU_WR nem aktiv, akkor vizsgalja hogy akar-e olvasni a CPU
	if ( nCPU_CE == 0 && nCPU_WR == 1 && ncpu_rd_edge == Lefuto_el && CPU_RS == 0 ) begin
		// CPU RAM olvasas
		if ( lcd_reg_select == 3 ) begin 
			cpu_ram_address 	<= cpu_tmp_address;
			// Ha kell, akkor lepteti a cimregisztert
			if ( ram_cur_step[7] == 0 ) cpu_tmp_address <= cpu_tmp_address + ram_cur_step[6:0]; else  cpu_tmp_address <= cpu_tmp_address - ram_cur_step[6:0];
			if ( cpu_tmp_address[17] == 0 ) begin 
				// Kulso RAM olvasas
				mem_req[cpu_ram_read_req] <= 1;		 // RAM olvasas hozzaferes igeny jelzes
				//ram_read_ready 			  <= 0;
				//ram_write_ready 			  <= 0;
			end
			else begin
				// Belso BLOCK RAM olvasas
				bram_mem_req[cpu_bram_read_req] <= 1;
				//bram_read_ready	<= 0;
				//bram_write_ready	<= 0;
			end
		end
	end


	// **********************
	// ***  CPU ---> FPGA ***
	// **********************
	//
	// CPU felol jovo adat betoltese a belso regiszterekbe a WR jel
	// lefuto ele utan ha az RD jel "H" szintu.
	//
	// Ha az nCPU_RD nem aktiv, akkor vizsgalja hogy akar-e irni a CPU
	if ( nCPU_CE == 0 && nCPU_RD == 1 && ncpu_wr_edge == Lefuto_el && CPU_RS == 1 ) begin	
			// regiszter kivalasztas
			lcd_reg_select <= CPU_DATA;
	end
		
	if ( nCPU_CE == 0 && nCPU_RD == 1 && ncpu_wr_edge == Lefuto_el && CPU_RS == 0 ) begin	
 
			//	RAM cim regiszter A17...A16 irasa
			if ( lcd_reg_select == 0 ) begin 
				//cpu_ram_address[17:16] <= CPU_DATA[1:0];
				cpu_tmp_address[17:16] <= CPU_DATA[1:0];
				lcd_reg_select <= lcd_reg_select + 1;
			end
			//	RAM cim regiszter felso byte irasa
			if ( lcd_reg_select == 1 ) begin 
				//cpu_ram_address[15:8] <= CPU_DATA;
				cpu_tmp_address[15:8] <= CPU_DATA;
				lcd_reg_select <= lcd_reg_select + 1;
			end
			//	RAM cim regiszter also byte irasa
			if ( lcd_reg_select == 2 ) begin 
				//cpu_ram_address[7:0]  <= CPU_DATA;
				cpu_tmp_address[7:0]  <= CPU_DATA;
				lcd_reg_select <= lcd_reg_select + 1;
			end
			// CPU ----> RAM iras
			if ( lcd_reg_select == 3 ) begin 
				cpu_ram_address 	<= cpu_tmp_address;
				// Ha kell, akkor lepteti a cimregisztert
				if ( ram_cur_step[7] == 0 ) cpu_tmp_address <= cpu_tmp_address + ram_cur_step[6:0]; else  cpu_tmp_address <= cpu_tmp_address - ram_cur_step[6:0];
				cpu_write_data 	<= CPU_DATA; 		// CPU adat a cpu_write_data regiszterbe
				if ( cpu_tmp_address[17] == 0 ) begin
					// Kulso RAM iras
					mem_req[cpu_ram_write_req] <= 1;		// RAM irass hozzaferes igeny jelzes irashoz
					//ram_write_ready 			   <= 0;	
					//ram_read_ready 			   <= 0;
				end
				else begin
					// Belso BLOCK RAM iras
					bram_mem_req[cpu_bram_write_req] <= 1;
					//bram_write_ready	<= 0;
					//bram_read_ready	<= 0;
				end
			end

			//	Layer0...5 es LCD engedelyezes
			if ( lcd_reg_select == 4 ) lcd_enable <= CPU_DATA;
												// b7 b6 b5 b4 b3 b2 b1 b0 --> lcd_enable
												//  |  |  |  |  |  |  |  |
												//  |  |  |  |  |  |  |   --> text_layer
												//  |  |  |  |  |  |   -----> layer0
												//  |  |  |  |  |   --------> layer1
												//  |  |  |  |   -----------> layer2
												//  |  |  |   --------------> layer3
												//  |  |   -----------------> 
												//  |   --------------------> lcd_inverse
												//   -----------------------> nLCD_DISP_OFF

			// Graphics_mode beallitasai
			if ( lcd_reg_select == 5 )	begin
				graph_blink_rate[3:0] <= CPU_DATA[3:0];
				char_blink_preset 	 <= 1;
			end

			// Layer0 mod beallitasa
			if ( lcd_reg_select == 6 )	begin
				layer0_bright 		<= CPU_DATA[1:0];
				layer0_bp 	  		<= CPU_DATA[2];
				layer0_blink_en	<= CPU_DATA[3];
				layer0_blink_inv	<= CPU_DATA[4];
			end
			
			// Layer0 kezdocim beallitas
			if ( lcd_reg_select == 7 ) begin
				layer0_start_hi <= CPU_DATA;
				lcd_reg_select  <= lcd_reg_select + 1;
			end
			if ( lcd_reg_select == 8 ) begin 
				layer0_start_lo     <= CPU_DATA;
				layer0_start_preset <= 1;
			end


			// Layer1 mod beallitasa
			if ( lcd_reg_select == 9 )	begin
				layer1_bright 		<= CPU_DATA[1:0];
				layer1_bp 	  		<= CPU_DATA[2];
				layer1_blink_en	<= CPU_DATA[3];
				layer1_blink_inv	<= CPU_DATA[4];
				layer1_mask_en		<= CPU_DATA[5];
			end
			
			// Layer1 kezdocim beallitas
			if ( lcd_reg_select == 10 ) begin
				layer1_start_hi <= CPU_DATA;
				lcd_reg_select  <= lcd_reg_select + 1;
			end
			if ( lcd_reg_select == 11 ) begin 
				layer1_start_lo 	  <= CPU_DATA;
				layer1_start_preset <= 1;
			end


			// Layer2 mod beallitasa
			if ( lcd_reg_select == 12 )	begin
				layer2_bright 		<= CPU_DATA[1:0];
				layer2_bp 	  		<= CPU_DATA[2];
				layer2_blink_en	<= CPU_DATA[3];
				layer2_blink_inv	<= CPU_DATA[4];
				layer2_mask_en		<= CPU_DATA[5];
			end
			
			// Layer2 kezdocim beallitas
			if ( lcd_reg_select == 13 ) begin
				layer2_start_hi <= CPU_DATA;
				lcd_reg_select  <= lcd_reg_select + 1;
			end
			if ( lcd_reg_select == 14 ) begin 
				layer2_start_lo 	  <= CPU_DATA;
				layer2_start_preset <= 1;
			end


			// Layer3 mod beallitasa
			if ( lcd_reg_select == 15 )	begin
				layer3_bright 		<= CPU_DATA[1:0];
				layer3_bp 	  		<= CPU_DATA[2];
				layer3_blink_en	<= CPU_DATA[3];
				layer3_blink_inv	<= CPU_DATA[4];
				layer3_mask_en		<= CPU_DATA[5];
			end
			
			// Layer3 kezdocim beallitas
			if ( lcd_reg_select == 16 ) begin
				layer3_start_hi <= CPU_DATA;
				lcd_reg_select  <= lcd_reg_select + 1;
			end
			if ( lcd_reg_select == 17 ) begin 
				layer3_start_lo     <= CPU_DATA;
				layer3_start_preset <= 1;
			end

			// Layerx mod beallitasa
			if ( lcd_reg_select == 18 )	begin
				layerx_bright <= CPU_DATA[1:0];
				layerx_bp 	  <= CPU_DATA[2];
			end
			
			// Layerx kezdocim beallitas
			if ( lcd_reg_select == 19 ) begin
				layerx_start_addr[15:8] <= CPU_DATA;
				lcd_reg_select     <= lcd_reg_select + 1;
			end
			if ( lcd_reg_select == 20 ) begin 
				layerx_start_addr[7:0] <= CPU_DATA;
			end



				
			// Text layer mode reg
			if ( lcd_reg_select == 21 ) begin 
				char_blink_preset <= 1;
				text_mode 			<= CPU_DATA;
							// b7 b6 b5 b4 b3 b2 b1 b0 			
							//  |  |  |  |  |  |  |  |
							//  |  |  |  |  |  |  |   --> char_gen_size 0=8, 1=12 pont magas
							//  |  |  |  |  |  |   -----> char_size[0]
							//  |  |  |  |  |   --------> char_size[1]
							//  |  |  |  |   -----------> char_size[2]
							//  |  |  |   --------------> char_blink_rate[0]
							//  |  |   -----------------> char_blink_rate[1]
							//  |   --------------------> char_blink_rate[2]
							//   -----------------------> char_blink_rate[3]
			end
			
			// Text layer kezdocim beallitas
			if ( lcd_reg_select == 22 ) begin
				text_start_hi 	<= CPU_DATA;
				lcd_reg_select <= lcd_reg_select + 1;
			end
			if ( lcd_reg_select == 23 ) begin 
				text_start_lo 		<= CPU_DATA;
				text_start_preset <= 1;
			end
			
			// Kulso karakter generator kezdocim beallitas
			if ( lcd_reg_select == 24 ) begin 
				ext_cgrom_start_addr[16:9] <= CPU_DATA;
				lcd_reg_select <= lcd_reg_select + 1;
			end
			if	( lcd_reg_select == 25 ) ext_cgrom_start_addr[8:0]  <= { CPU_DATA, 1'b0 };

			// X, Y automatikus inkrementalas
			if	( lcd_reg_select == 26 ) begin 
				x_auto_inc[3:0]  <= CPU_DATA[3:0];
				y_auto_inc[3:0]  <= CPU_DATA[7:4];
			end

			// Szagatott vonalhoz a minta HI byte betoltese
			if	( lcd_reg_select == 27 ) begin 
				dashed_pattern[15:8]	<= CPU_DATA[7:0];
				pattern_pointer[3:0] <= 0; // szaggatott vonal mintazat elejere
				lcd_reg_select <= lcd_reg_select + 1;
			end

			// Szagatott vonalhoz a minta LO byte betoltese
			if	( lcd_reg_select == 28 ) begin 
				dashed_pattern[7:0]	<= CPU_DATA[7:0];
				pattern_pointer[3:0] <= 0; // szaggatott vonal mintazat elejere
			end

			// Szagatott vonalhoz a minta cimzes beallitasa
			if	( lcd_reg_select == 29 ) begin 
				pattern_pointer[3:0] <= CPU_DATA[3:0];
			end


			// GPU Funkciok
			//-------------------------------------
			if ( lcd_reg_select == 30 ) begin 
				pixel_write_mode[3:0] <= CPU_DATA[3:0];// 0 = Normal
																   // 1 = Overwrite
																   // 2 = OR
																	// 3 = XOR
																   // 4 = AND
																	// 5 = INVERZ
																	// 6 = Bright DEC
																	// 7 = Bright INC
				function_select[3:0]	 <= CPU_DATA[7:4];// Ennek erteketol fuggoen fogja elinditani
																	// a grafikai modulokat es a parameter betoltes is
																	// ennek megfeleloen fog megtortenni
																	// 0 = pont 
																	// 1 = vonal
																	// 2 = kor
																	// 3 = blokk

				lcd_reg_select <= lcd_reg_select + 1;
			end
			if ( lcd_reg_select == 31 ) begin 
				// X high
				x[8] 			<= CPU_DATA[0];
				lcd_reg_select <= lcd_reg_select + 1;
			end
			if ( lcd_reg_select == 32 ) begin 
				// X low
				x[7:0] 			<= CPU_DATA;
				lcd_reg_select <= lcd_reg_select + 1;
			end
			if	( lcd_reg_select == 33 ) begin 
				// Y
				y  		  <= CPU_DATA;
				if ( function_select == 0 ) /* PLOT */ lcd_reg_select <= 37; else lcd_reg_select <= lcd_reg_select + 1;
			end
			if ( lcd_reg_select == 34 ) begin 
				// X1 high
				x1[8] 			<= CPU_DATA[0];
				lcd_reg_select <= lcd_reg_select + 1;
			end
			if ( lcd_reg_select == 35 ) begin 
				// X1 low
				x1[7:0] 			<= CPU_DATA;
				lcd_reg_select <= lcd_reg_select + 1;
			end
			if	( lcd_reg_select == 36 ) begin 
				// Y1
				y1  		  		<= CPU_DATA;
				case ( function_select ) 
					1: lcd_reg_select <= 38; // Vonal
					2: lcd_reg_select <= 39; // Kor
					3: lcd_reg_select <= 40; // Blokk
					default: lcd_reg_select <= lcd_reg_select + 1;
				endcase
			end
			
			// Pont
			if	( lcd_reg_select == 37 ) begin
				plot_pixel_bright[1:0]		<= CPU_DATA[1:0]; // A pixel fenyero
				plot_attr						<= CPU_DATA[2];   // sprite attributum
				layer_select[2:0]		  		<= CPU_DATA[5:3]; // A rajzolando layer kivalasztasa
				// layer bit/pixel ertekenek kiolvasasa
				case ( CPU_DATA[5:3] )
					0: pixel_bp <= layer0_bp;
					1: pixel_bp <= layer1_bp;
					2: pixel_bp <= layer2_bp;
					3: pixel_bp <= layer3_bp;
					4: pixel_bp <= layerx_bp;
					5: pixel_bp <= 1;
					6: pixel_bp <= 1;
					7: pixel_bp <= 1;
				endcase
				sprite_attr_write_en	<= CPU_DATA[6];
				// Csak akkor inditja a pont rajzolast, ha a bit7=0
				// A POINT funkcio eseten ezt 1-be kell irni es utana
				// ugyanerrol a cimrol olvasva lehet a POINT funkciot
				// inditani es kiolvasni a pont adatait.
				if ( CPU_DATA[7] == 0 )	cpu_plot_start <= 1; else cpu_point_start <= 1;
			end
						
			// Vonal
			if	( lcd_reg_select == 38 ) begin
				plot_pixel_bright[1:0]		<= CPU_DATA[1:0]; // A pixel fenyero
				plot_attr						<= CPU_DATA[2];	// Sprite attributum
				layer_select[2:0]		  		<= CPU_DATA[5:3]; // A rajzolando layer kivalasztasa
				// layer bit/pixel ertekenek kiolvasasa
				case ( CPU_DATA[5:3] )
					0: pixel_bp <= layer0_bp;
					1: pixel_bp <= layer1_bp;
					2: pixel_bp <= layer2_bp;
					3: pixel_bp <= layer3_bp;
					4: pixel_bp <= layerx_bp;
					5: pixel_bp <= 1;
					6: pixel_bp <= 1;
					7: pixel_bp <= 1;
				endcase
				sprite_attr_write_en	<= CPU_DATA[6];
				cpu_line_draw_start 	<= 1;
				plot_ct					<= 0;
			end
			
			// Kor rajzolas
			if	( lcd_reg_select == 39 ) begin
				plot_pixel_bright[1:0]		<= CPU_DATA[1:0]; // A pixel fenyero
				plot_attr						<= CPU_DATA[2];	// Sprite attributum
				layer_select[2:0]		  		<= CPU_DATA[5:3]; // A rajzolando layer kivalasztasa
				// layer bit/pixel ertekenek kiolvasasa
				case ( CPU_DATA[5:3] )
					0: pixel_bp <= layer0_bp;
					1: pixel_bp <= layer1_bp;
					2: pixel_bp <= layer2_bp;
					3: pixel_bp <= layer3_bp;
					4: pixel_bp <= layerx_bp;
					5: pixel_bp <= 1;
					6: pixel_bp <= 1;
					7: pixel_bp <= 1;
				endcase
				sprite_attr_write_en	<= CPU_DATA[6];
				cpu_circle_start 		<= 1;
				plot_ct					<= 0;
			end

			// Blokk mozgatas/masolas
			if	( lcd_reg_select == 40 ) begin
				block_mode[4:0]  		  <= CPU_DATA[4:0]; // bit[0]		0=Normal, 1=MOVE
																	  // bit[1]    0=Normal, 1=FILL
																	  // bit[2]		0=MIRROR, 1=ROTATE
																	  // 	bit[4:3] 	0= no mirror
																	  //			  		1= x mirror
																	  //					2= y mirror
																	  //					3= xy mirror
																	  // 	bit[4:3]		0=   0 deg rotate
																	  //					1=  90 deg rotate
																	  //					2= 180 deg rotate
																	  //					3= 270 deg rotate
				lcd_reg_select <= lcd_reg_select + 1;
			end
			if	( lcd_reg_select == 41 ) begin
				block_width[8]	<= CPU_DATA[0];
				lcd_reg_select <= lcd_reg_select + 1;
			end
			if	( lcd_reg_select == 42 ) begin
				block_width[7:0]	<= CPU_DATA;
				lcd_reg_select 	<= lcd_reg_select + 1;
			end
			if	( lcd_reg_select == 43 ) begin
				block_height	<= CPU_DATA;
				lcd_reg_select <= lcd_reg_select + 1;
			end
			if	( lcd_reg_select == 44 ) begin
				source_layer[2:0]		  <= CPU_DATA[2:0]; 	// forras layer kivalasztasa
				target_layer[2:0]		  <= CPU_DATA[5:3]; 	// cel layer kivalasztasa
				block_fill_bright[1:0] <= CPU_DATA[7:6];  // fill funkcional a pixel fenyero
				// forras layer bit/pixel ertekenek kiolvasasa
				case ( CPU_DATA[2:0] )
					0: source_layer_bp <= layer0_bp;
					1: source_layer_bp <= layer1_bp;
					2: source_layer_bp <= layer2_bp;
					3: source_layer_bp <= layer3_bp;
					4: source_layer_bp <= layerx_bp;
					5: source_layer_bp <= 1;
					6: source_layer_bp <= 1;
					7: source_layer_bp <= 1;
				endcase
				// cel layer bit/pixel ertekenek kiolvasasa
				case ( CPU_DATA[5:3] )
					0: target_layer_bp <= layer0_bp;
					1: target_layer_bp <= layer1_bp;
					2: target_layer_bp <= layer2_bp;
					3: target_layer_bp <= layer3_bp;
					4: target_layer_bp <= layerx_bp;
					5: target_layer_bp <= 1;
					6: target_layer_bp <= 1;
					7: target_layer_bp <= 1;
				endcase
				// Csak akkor inditja a blokk muveletet, ha van ertelme
				if ( block_width != 0 && block_height != 0 ) begin
					sprite_attr_write_en <= 0;
					cpu_block_start 		<= 1;
				end
			end

			// PLOT funkcio korlatozasa
			if ( lcd_reg_select == 45 ) begin 
				// max_plot_ct high
				max_plot_ct[8]	<= CPU_DATA[0];
				lcd_reg_select <= lcd_reg_select + 1;
			end
			if ( lcd_reg_select == 46 ) begin 
				// max_plot_ct low
				max_plot_ct[7:0] <= CPU_DATA;
				lcd_reg_select   <= 30; // GPU regiszter cime
			end
			


			// Sprite0 meret
			if ( lcd_reg_select == 60 ) begin 
				sprite0_width[6:0] <= CPU_DATA[6:0];
				lcd_reg_select   <= lcd_reg_select + 1;
			end
			if ( lcd_reg_select == 61 ) begin 
				sprite0_height[7:0] <= CPU_DATA;
				lcd_reg_select   <= lcd_reg_select + 1;
			end
			// Sprite0 pozicio
			if ( lcd_reg_select == 62 ) begin 
				cpu_sprite0_x_pos[8] <= CPU_DATA[0];
				lcd_reg_select   <= lcd_reg_select + 1;
			end
			if ( lcd_reg_select == 63 ) begin 
				cpu_sprite0_x_pos[7:0] <= CPU_DATA;
				lcd_reg_select 	 <= lcd_reg_select + 1;
			end
			if	( lcd_reg_select == 64 ) begin 
				cpu_sprite0_y_pos  <= CPU_DATA;
				sprite0_pos_preset <= 1;
			end


			// Sprite1 meret
			if ( lcd_reg_select == 65 ) begin 
				sprite1_width[6:0] <= CPU_DATA[6:0];
				lcd_reg_select   <= lcd_reg_select + 1;
			end
			if ( lcd_reg_select == 66 ) begin 
				sprite1_height[7:0] <= CPU_DATA;
				lcd_reg_select   <= lcd_reg_select + 1;
			end
			// Sprite1 pozicio
			if ( lcd_reg_select == 67 ) begin 
				cpu_sprite1_x_pos[8] <= CPU_DATA[0];
				lcd_reg_select   <= lcd_reg_select + 1;
			end
			if ( lcd_reg_select == 68 ) begin 
				cpu_sprite1_x_pos[7:0] <= CPU_DATA;
				lcd_reg_select 	 <= lcd_reg_select + 1;
			end
			if	( lcd_reg_select == 69 ) begin 
				cpu_sprite1_y_pos  <= CPU_DATA;
				sprite1_pos_preset <= 1;
			end


			// Sprite2 meret
			if ( lcd_reg_select == 70 ) begin 
				sprite2_width[6:0] <= CPU_DATA[6:0];
				lcd_reg_select   <= lcd_reg_select + 1;
			end
			if ( lcd_reg_select == 71 ) begin 
				sprite2_height[7:0] <= CPU_DATA;
				lcd_reg_select   <= lcd_reg_select + 1;
			end
			// Sprite2 pozicio
			if ( lcd_reg_select == 72 ) begin 
				cpu_sprite2_x_pos[8] <= CPU_DATA[0];
				lcd_reg_select   <= lcd_reg_select + 1;
			end
			if ( lcd_reg_select == 73 ) begin 
				cpu_sprite2_x_pos[7:0] <= CPU_DATA;
				lcd_reg_select 	 <= lcd_reg_select + 1;
			end
			if	( lcd_reg_select == 74 ) begin 
				cpu_sprite2_y_pos  <= CPU_DATA;
				sprite2_pos_preset <= 1;
			end

			// Sprite engedelyezo regiszter
			if	( lcd_reg_select == 75 ) begin 
				sprite_enable <= CPU_DATA[5:0];
			end

			// ***************** I/O *************************
			
			// Port0 kimenete
			if	( lcd_reg_select == 128 ) begin 
				p0_out <= CPU_DATA;
			end
			// Port0 irany
			if	( lcd_reg_select == 130 ) begin 
				p0_dir <= CPU_DATA;
			end
			// Port0 alternativ funkcio
			//if	( lcd_reg_select == 131 ) begin 
			//	p0_alt <= CPU_DATA;
			//end
			
			
			// Port1 kimenete
			if	( lcd_reg_select == 132 ) begin 
				p1_out <= CPU_DATA;
			end
			// Port1 irany
			if	( lcd_reg_select == 134 ) begin 
				p1_dir <= CPU_DATA;
			end
			// Port1 alternativ funkcio
			//if	( lcd_reg_select == 135 ) begin 
			//	p1_alt <= CPU_DATA;
			//end
			
			// Port2 kimenete
			if	( lcd_reg_select == 136 ) begin 
				p2_out <= CPU_DATA;
			end
			// Port2 irany
			if	( lcd_reg_select == 138 ) begin 
				p2_dir <= CPU_DATA;
			end
			// Port2 alternativ funkcio
			if	( lcd_reg_select == 139 ) begin 
				p2_alt <= CPU_DATA;
			end
			
			// Port3 kimenete
			if	( lcd_reg_select == 140 ) begin 
				p3_out <= CPU_DATA;
			end
			// Port3 irany
			if	( lcd_reg_select == 142 ) begin 
				p3_dir <= CPU_DATA;
			end
			// Port3 alternativ funkcio
			if	( lcd_reg_select == 143 ) begin 
				p3_alt[2:0] <= CPU_DATA[2:0];
			end

			
			// ENC0 set
			if	( lcd_reg_select == 145 ) begin 
				set_data	 <= CPU_DATA;
				set_enc0 <= 1;
			end
			// ENC1 set
			if	( lcd_reg_select == 146 ) begin 
				set_data	 <= CPU_DATA;
				set_enc1 <= 1;
			end
			// ENC2 set
			if	( lcd_reg_select == 147 ) begin 
				set_data	 <= CPU_DATA;
				set_enc2 <= 1;
			end
			// ENC3 set
			if	( lcd_reg_select == 148 ) begin 
				set_data	 <= CPU_DATA;
				set_enc3 <= 1;
			end
			
			if	( lcd_reg_select == 149 ) begin 
				{ enc_dir, enc_mode } <= CPU_DATA;
			end
			
			if	( lcd_reg_select == 150 ) begin 
				enc_type <= CPU_DATA[3:0];
			end
			
			
			//8 bit-es PWM  0, 1, 2
			if	( lcd_reg_select == 151 ) begin 
				pwm8_0_in	 <= CPU_DATA;
			end
			if	( lcd_reg_select == 152 ) begin 
				pwm8_1_in	 <= CPU_DATA;
			end
			if	( lcd_reg_select == 153 ) begin 
				pwm8_2_in	 <= CPU_DATA;
			end
			if	( lcd_reg_select == 154 ) begin 
				pwm8_div	 	 <= CPU_DATA;
			end
		
		
			if	( lcd_reg_select == 155 ) begin 
				pwm_buzzer_in	 <= CPU_DATA;
			end
			if	( lcd_reg_select == 156 ) begin 
				pwm_buzzer_div	 <= CPU_DATA;
			end
			
			

			if	( lcd_reg_select == 157 ) begin 
				set_data  <= CPU_DATA;
				lcd_reg_select   <= lcd_reg_select + 1;
			end
			if	( lcd_reg_select == 158 ) begin 
				pwm12_0_in <= { set_data[3:0], CPU_DATA };
			end
			if	( lcd_reg_select == 159 ) begin 
				set_data  <= CPU_DATA;
				lcd_reg_select   <= lcd_reg_select + 1;
			end
			if	( lcd_reg_select == 160 ) begin 
				pwm12_1_in <= { set_data[3:0], CPU_DATA };
			end
			if	( lcd_reg_select == 161 ) begin 
				set_data  <= CPU_DATA;
				lcd_reg_select   <= lcd_reg_select + 1;
			end
			if	( lcd_reg_select == 162 ) begin 
				pwm12_2_in <= { set_data[3:0], CPU_DATA };
			end
			if	( lcd_reg_select == 163 ) begin 
				set_data  <= CPU_DATA;
				lcd_reg_select   <= lcd_reg_select + 1;
			end
			if	( lcd_reg_select == 164 ) begin 
				pwm12_3_in <= { set_data[3:0], CPU_DATA };
			end
		
			if	( lcd_reg_select == 165 ) begin 
				pwm12_div <= CPU_DATA[3:0];
			end
			
	

			
			// Trigger szint
			if	( lcd_reg_select == 200 ) begin 
				trigger_level <= CPU_DATA;
			end

			// Trigger_mode stb
			if	( lcd_reg_select == 201 ) begin 
				trigger_mode <= CPU_DATA[3:0];
				hyst_level	 <= CPU_DATA[7:4];
			end
			
			// Idoalap
			if	( lcd_reg_select == 204 ) begin 
				time_div[23:16] <= CPU_DATA;
				lcd_reg_select   <= lcd_reg_select + 1;
			end
			if	( lcd_reg_select == 205 ) begin 
				time_div[15:8] <= CPU_DATA;
				lcd_reg_select   <= lcd_reg_select + 1;
			end
			if	( lcd_reg_select == 206 ) begin 
				time_div[7:0] <= CPU_DATA;
			end
		
			// mintaveteli hossz
			if	( lcd_reg_select == 207 ) begin 
				sample_len[15:8] <= CPU_DATA;
				lcd_reg_select   <= lcd_reg_select + 1;
			end
			if	( lcd_reg_select == 208 ) begin 
				sample_len[7:0] <= CPU_DATA;
			end
			
			if	( lcd_reg_select == 209 ) begin 
				//trigger_en	 <= CPU_DATA[0];
				if ( CPU_DATA[0] == 1 ) trigger_en <= ~trigger_en;
				if ( CPU_DATA[0] == 1 ) scope_irq  <= 1;
				//sample_ct_en <= CPU_DATA[1];
				if ( CPU_DATA[1] == 1 ) sample_ct_en <= ~sample_ct_en;
				//write_en 	 <= CPU_DATA[2];
				if ( CPU_DATA[2] == 1 ) write_en <= ~write_en;
				write_gate2	 <= CPU_DATA[3];
				scope_stop	 <= CPU_DATA[4];
				dig_mode		 <= CPU_DATA[5];
				scope_irq_en <= CPU_DATA[6];
			end


			// DSO mask regiszter
			if	( lcd_reg_select == 212 ) dig_mask <= CPU_DATA;
			
			// Scope interrupt torles
			if	( lcd_reg_select == 213 ) scope_irq <= 1;
			
			
			
			// Automatikus RAM cim leptetes beallitas
			if ( lcd_reg_select == 250 ) begin 
				ram_cur_step <= CPU_DATA;
			end


			// Setup1_reg beallitas
			if ( lcd_reg_select == 255 ) begin 
				ram_pri 					<= CPU_DATA[0];
				refress_rate[4:0] 	<= CPU_DATA[5:1];
				adc_seq					<= CPU_DATA[6];  // A PORT1-hey kapcsolt A/D bitsorrendjed allitja be
				screen_capture_start	<= CPU_DATA[7];  // Ha 1, akkor inditja a lepernyo mentest
			end

	
	end

	// ***************
	// Screen capture 
	// ***************
	if ( screen_capture_start == 1 ) begin
	
		case ( capture_state ) 
			0: begin	
					// kezdocim beallitasa
					capture_ram_address[16:0] <= { layerx_start_addr[15:0], 1'b0 };
					capture_state 				  <= capture_state + 1;
				end
			1: begin
					if ( lcd_strobe_cikl == 0 && lcd_cp_elott == 1 ) begin
						// Screen capture relativ cimszamlalojanak kezelese
						if ( lcd_x_ct == 78 && lcd_y_ct_max == 1 ) begin
							capture_ct 			 				 <= 0;
							mem_req[capture_write_mem_req] <= 1; // RAM iras inditas
							capture_write_ready				 <= 0;
							capture_state 		 				 <= 3;
						end
					end
				end
			2: begin
					if ( lcd_strobe_cikl == 0 && lcd_cp_elott == 1 ) begin
						capture_ram_address				 <= { layerx_start_addr[15:0], 1'b0 } + capture_ct; // RAM cim eloallitas
						mem_req[capture_write_mem_req] <= 1; 										  // RAM iras inditas
						capture_write_ready				 <= 0;
						capture_state 						 <= 3;
					end
				end
			3: begin
					if ( capture_ct == 19199 ) begin
						// Elkeszult:
						capture_state 			<= 0; // case elejere
						screen_capture_start <= 0;	// Start jel torles
					end
					else begin
						// Van meg menteni valo
						if ( capture_write_ready == 1 ) begin
							capture_ct 	  <= capture_ct + 1;	 // relativ cim noveles
							capture_state <= 2;
						end
					end
				end
		endcase
		
	end

	
	if ( frame_start == 1 ) begin
		char_gen_size  	<= text_mode[0];
		if ( text_mode[0] == 0 ) char_end <= 7; else char_end <= 11;
		char_size 			<= text_mode[3:1] + 7;
		char_blink_rate	<= text_mode[7:4];

		text_layer_enable <= lcd_enable[0];
		
		if ( lcd_enable[1] == 1 ) begin
			if ( layer0_blink_en == 1 ) begin
				layer0_enable <= graph_blink_bit + layer0_blink_inv;
			end
			else begin
				layer0_enable <= 1;
			end
		end else  layer0_enable <= 0;
		
		if ( lcd_enable[2] == 1 ) begin
			if ( layer1_blink_en == 1 ) begin
				layer1_enable <= graph_blink_bit + layer1_blink_inv;
			end
			else begin
				layer1_enable <= 1;
			end
		end 
		else begin 
			layer1_enable <= 0;
		end
		
		if ( lcd_enable[3] == 1 ) begin
			if ( layer2_blink_en == 1 ) begin
				layer2_enable <= graph_blink_bit + layer2_blink_inv;
			end
			else begin
				layer2_enable <= 1;
			end
		end
		else begin 
			layer2_enable <= 0; 
		end
		
		if ( lcd_enable[4] == 1 ) begin
			if ( layer3_blink_en == 1 ) begin
				layer3_enable <= graph_blink_bit + layer3_blink_inv;
			end
			else begin
				layer3_enable <= 1;
			end
		end 
		else begin
			layer3_enable <= 0;
		end
		
		//layer0_enable 		<= lcd_enable[1];
		//layer1_enable 		<= lcd_enable[2];
		//layer2_enable 		<= lcd_enable[3];
		//layer3_enable 		<= lcd_enable[4];
		
		nLCD_DISP_OFF 		<= lcd_enable[7];

		if ( text_start_preset == 1 ) begin 
			text_start_addr 		<= {text_start_hi, text_start_lo};
			text_start_preset 	<= 0;
		end
		if ( layer0_start_preset == 1 ) begin 
			layer0_start_addr 	<= {layer0_start_hi, layer0_start_lo};
			layer0_start_preset 	<= 0;
		end
		if ( layer1_start_preset == 1 ) begin 
			layer1_start_addr 	<= {layer1_start_hi, layer1_start_lo};
			layer1_start_preset 	<= 0;
		end
		if ( layer2_start_preset == 1 ) begin 
			layer2_start_addr 	<= {layer2_start_hi, layer2_start_lo};
			layer2_start_preset 	<= 0;
		end
		if ( layer3_start_preset == 1 ) begin 
			layer3_start_addr 	<= {layer3_start_hi, layer3_start_lo};
			layer3_start_preset 	<= 0;
		end
		
		if ( sprite0_pos_preset == 1 ) begin
			sprite0_x_pos <= cpu_sprite0_x_pos;
			sprite0_y_pos <= cpu_sprite0_y_pos;
			sprite0_pos_preset <= 0;
		end
		if ( sprite1_pos_preset == 1 ) begin
			sprite1_x_pos <= cpu_sprite1_x_pos;
			sprite1_y_pos <= cpu_sprite1_y_pos;
			sprite1_pos_preset <= 0;
		end
		if ( sprite2_pos_preset == 1 ) begin
			sprite2_x_pos <= cpu_sprite2_x_pos;
			sprite2_y_pos <= cpu_sprite2_y_pos;
			sprite2_pos_preset <= 0;
		end
		sprite0_en  	 <= sprite_enable[0];
		sprite0_attr_en <= sprite_enable[1];
		sprite1_en  	 <= sprite_enable[2];
		sprite1_attr_en <= sprite_enable[3];
		sprite2_en  	 <= sprite_enable[4];
		sprite2_attr_en <= sprite_enable[5];
	end


	// Pixel modul felol 1 clk ideig tarto RAM keres beirasa a megfelelo
	// mem_req vagy bram_mem_req regiszterbe
	if( pixel_read_req       == 1 ) mem_req[pixel_read_mem_req]  			  <= 1;
	if( pixel_write_req      == 1 ) mem_req[pixel_write_mem_req] 			  <= 1;
	if( bram_pixel_read_req  == 1 ) bram_mem_req[pixel_read_bram_mem_req]  <= 1;
	if( bram_pixel_write_req == 1 ) bram_mem_req[pixel_write_bram_mem_req] <= 1;


	// pixel ram muvelet kesz jelzes torles mert csak 1 clk ideig kell
	// ezek OR kapcsolatabol lessz a pixel_ram_ready jel
	pixel_read_ready  <= 0;
	pixel_write_ready <= 0;

	// CPU ram keres kesz jelzes beirasa, ezek logikai AND kapcsolata
	// lessz a CPU_READY jel.
	bram_read_ready	<= !bram_mem_req[cpu_bram_read_req];   
	bram_write_ready	<= !bram_mem_req[cpu_bram_write_req];  
	ram_read_ready 	<= !mem_req[cpu_ram_read_req]; 
	ram_write_ready 	<= !mem_req[cpu_ram_write_req];

	/********************\
	* BRAM iras/olvasas  *	
	\********************/
	// Prioritasba rendezve a ram hozzaferes engedelyezese
	// Sorrendben 	legmagasabb 	: 	 1 CPU olvasas   			 8 bit
	//											 2 CPU iras		  			 8 bit
	//  										 3 pixel olvasas			 8 bit
	// 				legalacsonyabb	:   4 pixel iras				 8 bit
	if ( bram_cikl == 0  &&  bram_mem_req_target != 0 ) begin
		bram_cikl 		 <= 1;
		bram_mem_target <= bram_mem_req_target;
		bram_mem_mode 	 <= bm_mode;
	end
	

	case ( bram_cikl )
		1: begin
				// BRAM iras / olvasas beallitas
				if ( bram_mem_mode == read ) begin
					bram_we  = 0;
				end
				if ( bram_mem_mode == write ) begin
					bram_we  = 1;
				end
				// BRAM cimbeallitas
				case ( bram_mem_target )
					1: begin // CPU olvas
							bram_addr[14:0] = cpu_ram_address[14:0];
						end
					2: begin // CPU ir
							bram_addr[14:0] = cpu_ram_address[14:0];
							bram_write_data = cpu_write_data; 
						end
					3:	begin // pixel olvasas
							bram_addr[14:0] = pixel_addr[14:0];
						end
					4: begin // pixel iras
							bram_addr[14:0] = pixel_addr[14:0];
							bram_write_data = pixel_write_data; 
						end
				endcase
				bram_cikl <= bram_cikl + 1;	
			end
		2: begin
				bram_clk	 <= 1;
				case ( bram_mem_target )
					  1: bram_mem_req[cpu_bram_read_req] 		  <= 0; 
					  2: bram_mem_req[cpu_bram_write_req]		  <= 0; 
					  3: bram_mem_req[pixel_read_bram_mem_req]  <= 0; 
					  4: bram_mem_req[pixel_write_bram_mem_req] <= 0; 
				endcase
				bram_cikl <= bram_cikl + 1;	
			end
		3: begin
				bram_clk <= 0;
				bram_we	= 0;
				if ( bram_mem_req_target != 0 ) begin
					bram_cikl 		 <= 1;
					bram_mem_target <= bram_mem_req_target;
					bram_mem_mode 	 <= bm_mode;
				end
				else begin
					bram_cikl 	<= 0;
				end

				//bram_read_ready	<= !bram_mem_req[cpu_bram_read_req];   
				//bram_write_ready	<= !bram_mem_req[cpu_bram_write_req];  
				//pixel_read_ready	<= !bram_mem_req[pixel_read_bram_mem_req]; 
				//pixel_write_ready	<= !bram_mem_req[pixel_write_bram_mem_req];

				
				case ( bram_mem_target )
					 //1: bram_read_ready    <= 1;
					 //2: bram_write_ready   <= 1;
					 3: pixel_read_ready	  <= 1;
					 4: pixel_write_ready  <= 1;
				endcase
				
				case ( bram_mem_target )
					1: cpu_read_data <= bram_read_data;
					2: begin end // CPU irasnal nem kell semmi
					3: pixel_read_data <= bram_read_data;
					4: begin end // Pixel irasnal nem kell semmi
				endcase
			end
	endcase



	/********************\
	* 	RAM iras/olvasas  *	
	\********************/
	// Prioritasba rendezve a ram hozzaferes engedelyezese
	// Sorrendben 	legmagasabb 	: 	 1 CPU olvasas   			 8 bit
	//											 2 CPU iras		  			 8 bit
	//											 3 Text layer olvasas  	16 bit
	//											 4 Ext. CGROM olvasas    8 bit
	//											 5 layer0 olvasas  		16 bit
	//											 6 layer1 olvasas  		16 bit
	//											 7 layer2 olvasas  		16 bit
	//											 8 layer3 olvasas  		16 bit
	//  										 9 pixel olvasas			 8 bit
	// 									   10 pixel iras				 8 bit
	// 				legalacsonyabb	:	11 Scren capture iras	 8 bit

	if ( ram_cikl == 0  &&  mem_req_target != 0 ) begin
		ram_cikl 	<= 1;
		mem_target  <= mem_req_target;
		mem_mode 	<= m_mode;
	end

	case ( ram_cikl )
		1: begin
				nRAM_WE	<= 1;
				nRAM_OE  <= 1;
				nRAM_LB 	 = 0;
				nRAM_UB 	 = 0;
				rambde   <= 1;
				ram_cikl <= ram_cikl + 1;	
				
				// RAM iras / olvasas beallitas
				if ( mem_mode == read ) begin
					nRAM_OE  <= 0;
				end
				if ( mem_mode == write ) begin
					nRAM_OE  <= 1;
				end
				
				// RAM cimbeallitas
				case ( mem_target )
					1: begin // CPU olvas
							RAM_ADDRESS[15:0] = cpu_ram_address[16:1];
							nRAM_LB =  cpu_ram_address[0];
							nRAM_UB = ~cpu_ram_address[0];
						end
					2: begin // CPU ir
							RAM_ADDRESS[15:0] = cpu_ram_address[16:1];
							nRAM_LB =  cpu_ram_address[0];
							nRAM_UB = ~cpu_ram_address[0];
							if ( cpu_ram_address[0] == 0 ) ram_write_data[7:0]  = cpu_write_data; else ram_write_data[15:8] = cpu_write_data;
						end
					3:	begin // text layer olvas
							RAM_ADDRESS[15:0]	= text_addr[15:0]; 
						end
					4:	begin // ext cgrom olvasas
							RAM_ADDRESS[15:0]	= ext_cgrom_addr[16:1]; 
							nRAM_LB =  ext_cgrom_addr[0];
							nRAM_UB = ~ext_cgrom_addr[0];
						end
					5:	begin // layer0 olvas
							RAM_ADDRESS[15:0]	= layer0_addr[15:0]; 
						end
					6:	begin // layer1 olvas
							RAM_ADDRESS[15:0]	= layer1_addr[15:0]; 
						end
					7:	begin // layer2 olvas
							RAM_ADDRESS[15:0]	= layer2_addr[15:0]; 
						end
					8:	begin // layer3 olvas
							RAM_ADDRESS[15:0]	= layer3_addr[15:0]; 
						end
					9: begin
							RAM_ADDRESS[15:0] = pixel_addr[16:1];
							nRAM_LB =  pixel_addr[0];
							nRAM_UB = ~pixel_addr[0];
						end
					10: begin
							RAM_ADDRESS[15:0] = pixel_addr[16:1];
							nRAM_LB =  pixel_addr[0];
							nRAM_UB = ~pixel_addr[0];
							if ( pixel_addr[0] == 0 ) ram_write_data[7:0]  = pixel_write_data; else ram_write_data[15:8] = pixel_write_data;
						 end
					11: begin
							RAM_ADDRESS[15:0] = capture_ram_address[16:1];
							nRAM_LB =  capture_ram_address[0];
							nRAM_UB = ~capture_ram_address[0];
							if ( capture_ram_address[0] == 0 ) ram_write_data[7:0]  = capture_write_data; else ram_write_data[15:8] = capture_write_data;
						 end
				endcase 
			end
		2: begin
				ram_cikl <= 3;
				if( mem_mode == write ) begin
					rambde   	<= 0;
					nRAM_WE		<= 0;
					nRAM_OE  	<= 1;
				end

				case ( mem_target )
					 1: mem_req[cpu_ram_read_req] 		<= 0; 
					 2: mem_req[cpu_ram_write_req]		<= 0; 
					 3: mem_req[text_mem_req] 				<= 0; 
					 4: mem_req[ext_cgrom_mem_req] 		<= 0; 
					 5: mem_req[layer0_mem_req] 			<= 0; 
					 6: mem_req[layer1_mem_req] 			<= 0; 
					 7: mem_req[layer2_mem_req] 			<= 0; 
					 8: mem_req[layer3_mem_req] 			<= 0; 
					 9: mem_req[pixel_read_mem_req] 		<= 0; 
					10: mem_req[pixel_write_mem_req] 	<= 0;
					11: mem_req[capture_write_mem_req] 	<= 0;
				endcase
					
			end
		3: begin
				rambde   <= 1;
				nRAM_WE	<= 1;
				nRAM_OE  <= 1;

				//ram_read_ready 	<= !mem_req[cpu_ram_read_req]; 
				//ram_write_ready 	<= !mem_req[cpu_ram_write_req];
				//text_ready 			<= !mem_req[text_mem_req]; 		
				//ext_cgrom_ready 	<= !mem_req[ext_cgrom_mem_req];
				//layer0_ready 		<= !mem_req[layer0_mem_req]; 	
				//layer1_ready 		<= !mem_req[layer1_mem_req]; 	
				//layer2_ready 		<= !mem_req[layer2_mem_req]; 	
				//layer3_ready 		<= !mem_req[layer3_mem_req]; 	
				//pixel_read_ready  <= !mem_req[pixel_read_mem_req];
				//pixel_write_ready <= !mem_req[pixel_write_mem_req];
				
				case ( mem_target )
				//	 1: ram_read_ready    	<= 1;
				//	 2: ram_write_ready   	<= 1;
					 3: text_ready	       	<= 1;
					 4: ext_cgrom_ready   	<= 1;
					 5: layer0_ready      	<= 1;
					 6: layer1_ready      	<= 1;
					 7: layer2_ready      	<= 1;
					 8: layer3_ready      	<= 1;
					 9: pixel_read_ready  	<= 1;
					10: pixel_write_ready 	<= 1;
					11: capture_write_ready <= 1;
				endcase
				
				if ( mem_req_target != 0 ) begin
					ram_cikl 	<= 1;
					mem_target  <= mem_req_target;
					mem_mode 	<= m_mode;
				end
				else begin
					ram_cikl 	<= 0;
				end

				case ( mem_target )
					1: if ( cpu_ram_address[0] == 0 ) cpu_read_data <= RAM_DATA[7:0];	else cpu_read_data <= RAM_DATA[15:8];
					2: begin end // CPU irasnal nem kell semmi
					3: begin 
							char_data		<= RAM_DATA[7:0];
							char_attr		<= RAM_DATA[15:8];
						end
					4: begin // Ext CGROM
							if ( ext_cgrom_addr[0] == 0 ) ext_cgrom_data <= RAM_DATA[7:0];	else ext_cgrom_data <= RAM_DATA[15:8];
						end
					5: begin 
							layer0_data	<= RAM_DATA;
						end
					6: begin 
							layer1_data	<= RAM_DATA; 
						end
					7: begin 
							layer2_data	<= RAM_DATA; 
						end
					8: begin 
							layer3_data	<= RAM_DATA; 
						end
					9: if ( pixel_addr[0] == 0 ) pixel_read_data <= RAM_DATA[7:0]; else pixel_read_data <= RAM_DATA[15:8];
					10: begin end // Pixel irasnal nem kell semmi
					11: begin end // screen capture eseten nem kell semmi
				endcase
			end
	endcase 



	
	// A kulonbozo layer-ek adatainak osszemasolasa
	// Csak tobb lepesben lehetseges, mert a 2 bit/pixel -es adatok miatt az
	// egyszeru logokai osszemasolas nem lehetseges
	case ( data_mixer_cikl )
		1:	begin
				// A karakteres layer eseten ket lepesben tortenik az adatok osszemasolasa,
				// mert a karaktergenarator olvasas tobb ciklust igenyel, foleg ha az a kulso
				// RAM-ban van. Ezert eloszor csak a kulso RAM-bol felolvasott 2 byte-bol a
				// karakter adatoktol fuggoen megcimzi a karaktergeneratort. A karaktergeneratorbol
				// kiolvasott adat majd csak a tenyleges adatosszemasolaskor lessz feldolgozva.
				//

				// Ha tiltva van a layer, akkor megy a kovetkezore
				if ( text_layer_enable == 0 ) begin
					data_mixer_cikl <= data_mixer_cikl + 1; // Layer 0 mixeles engedelzezes
				end
				else begin
					// A karaktergeneratorbol felolvassa a karakter adatokat
					if ( text_ready == 1 ) begin
						char_bright <= char_attr[2:1];
						case ( text_cikl )
							0: begin
									// karakter generator cimzes
									if ( char_gen_size == 0 ) begin 
										ext_cgrom_addr	<= char_data * 8 + char_line_ct + ext_cgrom_start_addr;
										// char_attr[7] a 2. karakter genarator kivalasztasa ha 1 a bit
										if ( char_attr[7] == 0 ) begin 
											cgrom_addr 		<= char_data * 8 + char_line_ct;
										end
										else begin
											cgrom_addr 		<= char_data * 8 + char_line_ct + 5120;
										end
									end
									else begin
										ext_cgrom_addr	<= char_data * 12 + char_line_ct + ext_cgrom_start_addr;
										// char_attr[7] a 2. karakter genarator kivalasztasa ha 1 a bit
										if ( char_attr[7] == 0 ) begin
											cgrom_addr 		<= char_data * 12 + char_line_ct + 2048;
										end
										else begin
											cgrom_addr 		<= char_data * 12 + char_line_ct + 5120;
										end
									end
									
									// Ha a karaktert a kulso CGROM-bol kell teriteni, akkor ram igeny jelzes
									if ( char_attr[0] == 1 ) begin 
										mem_req[ext_cgrom_mem_req] <= 1;
										ext_cgrom_ready 				<= 0;
									end
									
									case ( cgrom_addr[12:11] )
										0 : begin 
												cgrom0_en = 1; 
												cgrom1_en = 0;
												cgrom2_en = 0;
											end
										1 : begin 
												cgrom0_en = 0; 
												cgrom1_en = 1;
												cgrom2_en = 0;
											end
										2 : begin 
												cgrom0_en = 0; 
												cgrom1_en = 0;
												cgrom2_en = 1;
												end
										3 : begin 
												cgrom0_en = 0; 
												cgrom1_en = 0;
												cgrom2_en = 0;
											end
									endcase 
									text_cikl <= text_cikl + 1;
								end
							1:	begin
									if ( char_attr[0] == 0 ) begin 
										// Belso karaktergenerator
										cgrom_clk		 <= 1; // CGRAM clk = 1
										text_cikl 		 <= 0;
										data_mixer_cikl <= data_mixer_cikl + 1; // Layer 0 mixeles engedelzezes
									end
									else begin
										// Kulso karakter generator
										if ( ext_cgrom_ready == 1 ) begin 
											data_mixer_cikl <= data_mixer_cikl + 1;
											text_cikl 		 <= 0;
										end
									end
								end
						endcase
					end
				end
			end
		2: begin // Layer0 mixeles 
				if ( char_attr[0] == 1 ) begin 
					// Kulso karaktergenerator adatainak kiolvasasa
					cgrom_data <= ext_cgrom_data;
				end
				else begin 
					// Belso karaktergenerator adatainak kiolvasasa
					case ( cgrom_addr[12:11] )
						0: cgrom_data <= cgrom0_data_out; 
						1: cgrom_data <= cgrom1_data_out; 
						2: cgrom_data <= cgrom2_data_out;
						3: cgrom_data <= 0;
					endcase 
				end

				// Ha tiltva van a layer, akkor megy a kovetkezore
				if ( layer0_enable == 0 ) begin
					data_mixer_cikl <= data_mixer_cikl + 1; // Layer1 layer mixeles engedelzezes
				end
				else begin
					if ( layer0_ready == 1 ) begin
						data_mixer_cikl <= data_mixer_cikl + 1; // Layer1 layer mixeles engedelzezes
						if ( layer0_bp == 0 ) begin 
							if ( layer0_bright != 0 ) begin
								if ( lcd_data_puffer[1:0] < layer0_bright && layer0_data[ 0 + { lcd_1bp_addr_pointer[1], ~lcd_1bp_addr_pointer[0] } * 4] == 1 ) lcd_data_puffer[1:0] <= layer0_bright[1:0];
								if ( lcd_data_puffer[3:2] < layer0_bright && layer0_data[ 1 + { lcd_1bp_addr_pointer[1], ~lcd_1bp_addr_pointer[0] } * 4] == 1 ) lcd_data_puffer[3:2] <= layer0_bright[1:0];
								if ( lcd_data_puffer[5:4] < layer0_bright && layer0_data[ 2 + { lcd_1bp_addr_pointer[1], ~lcd_1bp_addr_pointer[0] } * 4] == 1 ) lcd_data_puffer[5:4] <= layer0_bright[1:0];
								if ( lcd_data_puffer[7:6] < layer0_bright && layer0_data[ 3 + { lcd_1bp_addr_pointer[1], ~lcd_1bp_addr_pointer[0] } * 4] == 1 ) lcd_data_puffer[7:6] <= layer0_bright[1:0];
							end
						end 
						else begin
							if (lcd_2bp_addr_pointer[0] == 0 ) begin
								if ( lcd_data_puffer [1:0] < layer0_data[9:8]   ) lcd_data_puffer[1:0] <= layer0_data[9:8];
								if ( lcd_data_puffer [3:2] < layer0_data[11:10] ) lcd_data_puffer[3:2] <= layer0_data[11:10];
								if ( lcd_data_puffer [5:4] < layer0_data[13:12] ) lcd_data_puffer[5:4] <= layer0_data[13:12];
								if ( lcd_data_puffer [7:6] < layer0_data[15:14] ) lcd_data_puffer[7:6] <= layer0_data[15:14];
							end 
							else begin
								if ( lcd_data_puffer [1:0] < layer0_data[1:0] ) lcd_data_puffer[1:0] <= layer0_data[1:0];
								if ( lcd_data_puffer [3:2] < layer0_data[3:2] ) lcd_data_puffer[3:2] <= layer0_data[3:2];
								if ( lcd_data_puffer [5:4] < layer0_data[5:4] ) lcd_data_puffer[5:4] <= layer0_data[5:4];
								if ( lcd_data_puffer [7:6] < layer0_data[7:6] ) lcd_data_puffer[7:6] <= layer0_data[7:6];
							end
						end
					end
				end
			end
		3:	begin // Layer1 mixeles 
				// Ha tiltva van a layer, akkor megy a kovetkezore
				if ( layer1_enable == 0 ) begin
					data_mixer_cikl <= data_mixer_cikl + 1; // Layer2 layer mixeles engedelzezes
				end
				else begin
					if ( layer1_ready == 1 ) begin
						data_mixer_cikl <= data_mixer_cikl + 1; // Layer2 layer mixeles engedelzezes
						if ( layer1_bp == 0 ) begin 
							if ( layer1_bright != 0 ) begin
								if ( lcd_data_puffer[1:0] <= layer1_bright && layer1_data[ 0 + { lcd_1bp_addr_pointer[1], ~lcd_1bp_addr_pointer[0] } * 4] == 1 ) begin 
									if ( layer1_mask_en == 0 ) lcd_data_puffer[1:0] <= layer1_bright[1:0]; else lcd_data_puffer[1:0] <= 0;
								end
								if ( lcd_data_puffer[3:2] <= layer1_bright && layer1_data[ 1 + { lcd_1bp_addr_pointer[1], ~lcd_1bp_addr_pointer[0] } * 4] == 1 ) begin 
									if ( layer1_mask_en == 0 ) lcd_data_puffer[3:2] <= layer1_bright[1:0]; else lcd_data_puffer[3:2] <= 0;
								end
								if ( lcd_data_puffer[5:4] <= layer1_bright && layer1_data[ 2 + { lcd_1bp_addr_pointer[1], ~lcd_1bp_addr_pointer[0] } * 4] == 1 ) begin 
									if ( layer1_mask_en == 0 ) lcd_data_puffer[5:4] <= layer1_bright[1:0]; else lcd_data_puffer[5:4] <= 0;
								end
								if ( lcd_data_puffer[7:6] <= layer1_bright && layer1_data[ 3 + { lcd_1bp_addr_pointer[1], ~lcd_1bp_addr_pointer[0] } * 4] == 1 ) begin 
									if ( layer1_mask_en == 0 ) lcd_data_puffer[7:6] <= layer1_bright[1:0]; else lcd_data_puffer[7:6] <= 0;
								end
							end
						end 
						else begin
							if (lcd_2bp_addr_pointer[0] == 0 ) begin
								if ( lcd_data_puffer [1:0] < layer1_data[9:8]   ) lcd_data_puffer[1:0] <= layer1_data[9:8];
								if ( lcd_data_puffer [3:2] < layer1_data[11:10] ) lcd_data_puffer[3:2] <= layer1_data[11:10];
								if ( lcd_data_puffer [5:4] < layer1_data[13:12] ) lcd_data_puffer[5:4] <= layer1_data[13:12];
								if ( lcd_data_puffer [7:6] < layer1_data[15:14] ) lcd_data_puffer[7:6] <= layer1_data[15:14];
							end 
							else begin
								if ( lcd_data_puffer [1:0] < layer1_data[1:0] ) lcd_data_puffer[1:0] <= layer1_data[1:0];
								if ( lcd_data_puffer [3:2] < layer1_data[3:2] ) lcd_data_puffer[3:2] <= layer1_data[3:2];
								if ( lcd_data_puffer [5:4] < layer1_data[5:4] ) lcd_data_puffer[5:4] <= layer1_data[5:4];
								if ( lcd_data_puffer [7:6] < layer1_data[7:6] ) lcd_data_puffer[7:6] <= layer1_data[7:6];
							end
						end
					end
				end

				// Ha a karakter generatorban tarolt karakternel nagyobb a 
				// sorszamlalo, akkor extra ures sorokat szur be amelyek atlatszoak
				if ( char_line_ct > char_end ) begin
					char_attr[3] <= 0;
					cgrom_data 	 <= 0;
				end
				else begin
					// char_attr[4] inverz 0=nem, 1=igen
					// statikusan invertalja a karaktert
					if ( char_attr[4] == 1 && char_attr[6:5] == 0 ) cgrom_data <= ~cgrom_data;
								
					// Karakter villogas 
					// 	char_attr[5] villogas mod bit0
					// 	char_attr[6] villogas mod bit1
					// 		0 = nem villog
					// 		1 = inverz villogas
					// 		2 = normal villogas				
					// 		3 = cursor villogas
					case ( char_attr[6:5] )
						1: if ( char_blink_bit == 1 ^ char_attr[4] == 1 ) cgrom_data <= ~cgrom_data; 
						2: if ( char_blink_bit == 1 ) cgrom_data <= 0;
						3: if ( char_blink_bit == 1 ) cgrom_data <= 255;
					endcase				
				end
				
			end
		5:	begin // Layer2 mixeles 
				// Ha tiltva van a layer, akkor megy a kovetkezore
				if ( layer2_enable == 0 ) begin
					data_mixer_cikl <= data_mixer_cikl + 1; // Layer3 layer mixeles engedelzezes
				end
				else begin
					if ( layer2_ready == 1 ) begin
						data_mixer_cikl <= data_mixer_cikl + 1; // Layer3 layer mixeles engedelzezes
						if ( layer2_bp == 0 ) begin 
							if ( layer2_bright != 0 ) begin
								if ( lcd_data_puffer[1:0] <= layer2_bright && layer2_data[ 0 + { lcd_1bp_addr_pointer[1], ~lcd_1bp_addr_pointer[0] } * 4] == 1 ) begin 
									if ( layer2_mask_en == 0 )	lcd_data_puffer[1:0] <= layer2_bright[1:0]; else lcd_data_puffer[1:0] <= 0;
								end
								if ( lcd_data_puffer[3:2] <= layer2_bright && layer2_data[ 1 + { lcd_1bp_addr_pointer[1], ~lcd_1bp_addr_pointer[0] } * 4] == 1 ) begin 
									if ( layer2_mask_en == 0 ) lcd_data_puffer[3:2] <= layer2_bright[1:0]; else lcd_data_puffer[3:2] <= 0;
								end
								if ( lcd_data_puffer[5:4] <= layer2_bright && layer2_data[ 2 + { lcd_1bp_addr_pointer[1], ~lcd_1bp_addr_pointer[0] } * 4] == 1 ) begin 
									if ( layer2_mask_en == 0 ) lcd_data_puffer[5:4] <= layer2_bright[1:0]; else lcd_data_puffer[5:4] <= 0;
								end
								if ( lcd_data_puffer[7:6] <= layer2_bright && layer2_data[ 3 + { lcd_1bp_addr_pointer[1], ~lcd_1bp_addr_pointer[0] } * 4] == 1 ) begin 
									if ( layer2_mask_en == 0 ) lcd_data_puffer[7:6] <= layer2_bright[1:0]; else lcd_data_puffer[7:6] <= 0;
								end
							end
						end 
						else begin
							if (lcd_2bp_addr_pointer[0] == 0 ) begin
								if ( lcd_data_puffer [1:0] < layer2_data[9:8]   ) lcd_data_puffer[1:0] <= layer2_data[9:8];
								if ( lcd_data_puffer [3:2] < layer2_data[11:10] ) lcd_data_puffer[3:2] <= layer2_data[11:10];
								if ( lcd_data_puffer [5:4] < layer2_data[13:12] ) lcd_data_puffer[5:4] <= layer2_data[13:12];
								if ( lcd_data_puffer [7:6] < layer2_data[15:14] ) lcd_data_puffer[7:6] <= layer2_data[15:14];
							end 
							else begin
								if ( lcd_data_puffer [1:0] < layer2_data[1:0] ) lcd_data_puffer[1:0] <= layer2_data[1:0];
								if ( lcd_data_puffer [3:2] < layer2_data[3:2] ) lcd_data_puffer[3:2] <= layer2_data[3:2];
								if ( lcd_data_puffer [5:4] < layer2_data[5:4] ) lcd_data_puffer[5:4] <= layer2_data[5:4];
								if ( lcd_data_puffer [7:6] < layer2_data[7:6] ) lcd_data_puffer[7:6] <= layer2_data[7:6];
							end
						end
					end
				end
				// Karakter villogas 
				// 	char_attr[5] villogas mod bit0
				// 	char_attr[6] villogas mod bit1
				// 		0 = nem villog
				// 		1 = inverz villogas
				// 		2 = normal villogas				
				// 		3 = cursor villogas
				//case ( char_attr[6:5] )
				//	1: if ( char_blink_bit == 1 ) cgrom_data <= ~cgrom_data;
				//	2: if ( char_blink_bit == 1 ) cgrom_data <= 0;
				//	3: if ( char_blink_bit == 1 ) cgrom_data <= 255;
				//endcase				
			end
		6:	begin // Layer3 mixeles 
				// Ha tiltva van a layer, akkor megy a kovetkezore
				if ( layer3_enable == 0 ) begin
					data_mixer_cikl <= data_mixer_cikl + 1; // Text layer mixeles engedelzezes
				end
				else begin
					if ( layer3_ready == 1 ) begin
						data_mixer_cikl <= data_mixer_cikl + 1; // Text layer mixeles engedelzezes
						if ( layer3_bp == 0 ) begin 
							if ( layer3_bright != 0 ) begin
								if ( lcd_data_puffer[1:0] <= layer3_bright && layer3_data[ 0 + { lcd_1bp_addr_pointer[1], ~lcd_1bp_addr_pointer[0] } * 4] == 1 ) begin 
									if ( layer3_mask_en == 0 ) lcd_data_puffer[1:0] <= layer3_bright[1:0]; else lcd_data_puffer[1:0] <= 0;
								end
								if ( lcd_data_puffer[3:2] <= layer3_bright && layer3_data[ 1 + { lcd_1bp_addr_pointer[1], ~lcd_1bp_addr_pointer[0] } * 4] == 1 ) begin 
									if ( layer3_mask_en == 0 ) lcd_data_puffer[3:2] <= layer3_bright[1:0]; else lcd_data_puffer[3:2] <= 0;
								end
								if ( lcd_data_puffer[5:4] <= layer3_bright && layer3_data[ 2 + { lcd_1bp_addr_pointer[1], ~lcd_1bp_addr_pointer[0] } * 4] == 1 ) begin 
									if ( layer3_mask_en == 0 ) lcd_data_puffer[5:4] <= layer3_bright[1:0]; else lcd_data_puffer[5:4] <= 0;
								end
								if ( lcd_data_puffer[7:6] <= layer3_bright && layer3_data[ 3 + { lcd_1bp_addr_pointer[1], ~lcd_1bp_addr_pointer[0] } * 4] == 1 ) begin 
									if ( layer3_mask_en == 0 ) lcd_data_puffer[7:6] <= layer3_bright[1:0]; else lcd_data_puffer[7:6] <= 0;
								end
							end
						end 
						else begin
							if (lcd_2bp_addr_pointer[0] == 0 ) begin
								if ( lcd_data_puffer [1:0] < layer3_data[9:8]   ) lcd_data_puffer[1:0] <= layer3_data[9:8];
								if ( lcd_data_puffer [3:2] < layer3_data[11:10] ) lcd_data_puffer[3:2] <= layer3_data[11:10];
								if ( lcd_data_puffer [5:4] < layer3_data[13:12] ) lcd_data_puffer[5:4] <= layer3_data[13:12];
								if ( lcd_data_puffer [7:6] < layer3_data[15:14] ) lcd_data_puffer[7:6] <= layer3_data[15:14];
							end 
							else begin
								if ( lcd_data_puffer [1:0] < layer3_data[1:0] ) lcd_data_puffer[1:0] <= layer3_data[1:0];
								if ( lcd_data_puffer [3:2] < layer3_data[3:2] ) lcd_data_puffer[3:2] <= layer3_data[3:2];
								if ( lcd_data_puffer [5:4] < layer3_data[5:4] ) lcd_data_puffer[5:4] <= layer3_data[5:4];
								if ( lcd_data_puffer [7:6] < layer3_data[7:6] ) lcd_data_puffer[7:6] <= layer3_data[7:6];
							end
						end
					end
				end
				// Ha a karakter generatorban tarolt karakternel nagyobb a 
				// sorszamlalo, akkor extra ures sorokat szur be amelyek atlatszoak
				//if ( char_line_ct > char_end ) begin
				//	char_attr[3] <= 0;
				//	cgrom_data 	 <= 0;
				//end
			end
		4:	begin // Text layer mixeles 
				// char_attr[3] atlatszosag. 0=igen, 1=nem 
				if ( char_attr[3] == 0 ) begin
					// atlatszo
					if ( lcd_x_ct[0] == 1 ) begin
						if ( cgrom_data[0] == 1 && ( lcd_data_puffer[1:0] < char_bright[1:0] ) ) lcd_data_puffer[1:0] <= char_bright;
						if ( cgrom_data[1] == 1 && ( lcd_data_puffer[3:2] < char_bright[1:0] ) ) lcd_data_puffer[3:2] <= char_bright;
						if ( cgrom_data[2] == 1 && ( lcd_data_puffer[5:4] < char_bright[1:0] ) ) lcd_data_puffer[5:4] <= char_bright;
						if ( cgrom_data[3] == 1 && ( lcd_data_puffer[7:6] < char_bright[1:0] ) ) lcd_data_puffer[7:6] <= char_bright;
					end
					else begin
						if ( cgrom_data[4] == 1 && ( lcd_data_puffer[1:0] < char_bright[1:0] ) ) lcd_data_puffer[1:0] <= char_bright;
						if ( cgrom_data[5] == 1 && ( lcd_data_puffer[3:2] < char_bright[1:0] ) ) lcd_data_puffer[3:2] <= char_bright;
						if ( cgrom_data[6] == 1 && ( lcd_data_puffer[5:4] < char_bright[1:0] ) ) lcd_data_puffer[5:4] <= char_bright;
						if ( cgrom_data[7] == 1 && ( lcd_data_puffer[7:6] < char_bright[1:0] ) ) lcd_data_puffer[7:6] <= char_bright;
					end
				end
				else begin 
					// nem atlatszo
					if ( lcd_x_ct[0] == 1 ) begin
						if ( cgrom_data[0] == 1 ) lcd_data_puffer[1:0] <= char_bright; else lcd_data_puffer[1:0] <= 0;
						if ( cgrom_data[1] == 1 ) lcd_data_puffer[3:2] <= char_bright; else lcd_data_puffer[3:2] <= 0;
						if ( cgrom_data[2] == 1 ) lcd_data_puffer[5:4] <= char_bright; else lcd_data_puffer[5:4] <= 0;
						if ( cgrom_data[3] == 1 ) lcd_data_puffer[7:6] <= char_bright; else lcd_data_puffer[7:6] <= 0;
					end
					else begin
						if ( cgrom_data[4] == 1 ) lcd_data_puffer[1:0] <= char_bright; else lcd_data_puffer[1:0] <= 0;
						if ( cgrom_data[5] == 1 ) lcd_data_puffer[3:2] <= char_bright; else lcd_data_puffer[3:2] <= 0;
						if ( cgrom_data[6] == 1 ) lcd_data_puffer[5:4] <= char_bright; else lcd_data_puffer[5:4] <= 0;
						if ( cgrom_data[7] == 1 ) lcd_data_puffer[7:6] <= char_bright; else lcd_data_puffer[7:6] <= 0;
					end
				end 
				data_mixer_cikl <= data_mixer_cikl + 1;
				cgrom_clk		 <= 0;
			end
		7:	begin 	//lcd_data_puffer <= sprite_data_puffer;
				if ( sprite0_ready == 1 ) begin 
					if ( sprite_attr_puffer[0] == 0 ) begin
						if ( sprite_data_puffer[1:0] > lcd_data_puffer[1:0] ) lcd_data_puffer[1:0] <= sprite_data_puffer[1:0];
					end
					else begin
						lcd_data_puffer[1:0] <= sprite_data_puffer[1:0];
					end
					
					if ( sprite_attr_puffer[1] == 0 ) begin
						if ( sprite_data_puffer[3:2] > lcd_data_puffer[3:2] ) lcd_data_puffer[3:2] <= sprite_data_puffer[3:2];
					end
					else begin
						lcd_data_puffer[3:2] <= sprite_data_puffer[3:2];
					end
					
					if ( sprite_attr_puffer[2] == 0 ) begin
						if ( sprite_data_puffer[5:4] > lcd_data_puffer[5:4] ) lcd_data_puffer[5:4] <= sprite_data_puffer[5:4];
					end
					else begin
						lcd_data_puffer[5:4] <= sprite_data_puffer[5:4];
					end
					
					if ( sprite_attr_puffer[3] == 0 ) begin
						if ( sprite_data_puffer[7:6] > lcd_data_puffer[7:6] ) lcd_data_puffer[7:6] <= sprite_data_puffer[7:6];
					end
					else begin
						lcd_data_puffer[7:6] <= sprite_data_puffer[7:6];
					end
					data_mixer_cikl <= 0;
				end
			end
	endcase
	
	
	case ( sprite_mixer_cikl ) 
		1: begin
				if ( sprite0_ready == 1 && sprite0_en == 1 ) begin 
					sprite_data_puffer <= sprite0_data;
					sprite_attr_puffer <= sprite0_attr;
				end
				if ( sprite0_ready == 1 ) sprite_mixer_cikl  <= 2;
			end
		2: begin
				if ( sprite1_en == 1 ) begin 
					if ( sprite1_attr[0] == 0 ) begin
						if ( sprite1_data[1:0] > sprite_data_puffer[1:0] ) sprite_data_puffer[1:0] <= sprite1_data[1:0];
					end
					else begin
						sprite_data_puffer[1:0] <= sprite1_data[1:0];
					end
					
					if ( sprite1_attr[1] == 0 ) begin
						if ( sprite1_data[3:2] > sprite_data_puffer[3:2] ) sprite_data_puffer[3:2] <= sprite1_data[3:2];
					end
					else begin
						sprite_data_puffer[3:2] <= sprite1_data[3:2];
					end
					
					if ( sprite1_attr[2] == 0 ) begin
						if ( sprite1_data[5:4] > sprite_data_puffer[5:4] ) sprite_data_puffer[5:4] <= sprite1_data[5:4];
					end
					else begin
						sprite_data_puffer[5:4] <= sprite1_data[5:4];
					end
					
					if ( sprite1_attr[3] == 0 ) begin
						if ( sprite1_data[7:6] > sprite_data_puffer[7:6] ) sprite_data_puffer[7:6] <= sprite1_data[7:6];
					end
					else begin
						sprite_data_puffer[7:6] <= sprite1_data[7:6];
					end
					sprite_attr_puffer <= sprite_attr_puffer | sprite1_attr;
				end
				sprite_mixer_cikl  <= 3;
			end
		3: begin
				if ( sprite2_en == 1 ) begin
					if ( sprite2_attr[0] == 0 ) begin
						if ( sprite2_data[1:0] > sprite_data_puffer[1:0] ) sprite_data_puffer[1:0] <= sprite2_data[1:0];
					end
					else begin
						sprite_data_puffer[1:0] <= sprite2_data[1:0];
					end
					
					if ( sprite2_attr[1] == 0 ) begin
						if ( sprite2_data[3:2] > sprite_data_puffer[3:2] ) sprite_data_puffer[3:2] <= sprite2_data[3:2];
					end
					else begin
						sprite_data_puffer[3:2] <= sprite2_data[3:2];
					end
					
					if ( sprite2_attr[2] == 0 ) begin
						if ( sprite2_data[5:4] > sprite_data_puffer[5:4] ) sprite_data_puffer[5:4] <= sprite2_data[5:4];
					end
					else begin
						sprite_data_puffer[5:4] <= sprite2_data[5:4];
					end
					
					if ( sprite2_attr[3] == 0 ) begin
						if ( sprite2_data[7:6] > sprite_data_puffer[7:6] ) sprite_data_puffer[7:6] <= sprite2_data[7:6];
					end
					else begin
						sprite_data_puffer[7:6] <= sprite2_data[7:6];
					end
					sprite_attr_puffer <= sprite_attr_puffer | sprite2_attr;
				end
				sprite_mixer_cikl  <= 0;
			end
	endcase

	sprite0_start	<= 0;
	sprite1_start	<= 0;
	sprite2_start	<= 0;

	case ( lcd_strobe_cikl )
		0: begin
				if ( lcd_cp_elott == 1 ) begin
					// Ha a DS2401 sorozatszama stimmel, csak akkor engedi az LCD terites adatait kirakni
					if ( sid_ok == 1 ) begin 
						if ( lcd_enable[6] == 0 ) begin 
							// normal megjelenites
							LCD_DATA 		    <= lookup_out;
							capture_write_data <= lcd_data_puffer;
						end
						else begin
							// inverz megjeleneites
							LCD_DATA 		    <= ~lookup_out;
							capture_write_data <= ~lcd_data_puffer;
						end
					end
					else begin
						LCD_DATA[3:1] 		    <= lookup_out[3:1];
						LCD_DATA[0] 		    <= 0;
						capture_write_data <= lcd_data_puffer;
						//LCD_DATA <= 8'h55;
					end

					lcd_data_puffer  		<= 0;
					sprite_data_puffer 	<= 0;
					sprite_attr_puffer	<= 0;
					lcd_strobe_cikl  		<= 1;
					
					
					
					// A karakteres sorok vegen a cimszamlalot noveli egy egesz sorral
					if ( lcd_x_ct == 76 && char_line_ct == char_size ) text_addr_pointer <= text_addr_pointer + 40;
					// A kulonbozo szamlalok leptetese a terites kozben
					if ( lcd_x_ct == 76 && lcd_y_ct_max == 1 ) begin
						// A terites vegen van, akkor minden text layer-hez tartozo 
						// regiszterbe betolti a kezdoerteket
						text_addr_pointer	<= 0;
						char_line_ct		<= char_size;
						x_ct					<= 0;
					end
					else begin
						// A karakter szamlalo leptetese
						if ( x_ct == 79 ) begin
							x_ct <= 0;
							if ( y_ct == 239 ) y_ct <= 0; else y_ct <= y_ct + 1;
						end
						else begin
							x_ct <= x_ct + 1;
						end
						// A karakteren beluli terites sorszamlalojanak leptetese
						if ( x_ct == 0 ) begin
							if ( char_line_ct == char_size ) begin
								char_line_ct <= 0;
							end
							else begin
								char_line_ct <= char_line_ct + 1;
							end
						end
					end
					// Sprite terites szamlaloinak leptetese
					if ( lcd_x_ct == 76 && lcd_y_ct_max == 1 ) begin 
						sprite_x_ct <= 0;
						sprite_y_ct <= 0;
					end
					else begin
						if ( sprite_x_ct == 79 ) begin
							sprite_x_ct <= 0;
							if ( sprite_y_ct == 239 ) sprite_y_ct <= 0; else sprite_y_ct <= sprite_y_ct + 1; 
						end
						else begin
							sprite_x_ct <= sprite_x_ct + 1;
						end
					end 
				end
			end
		1:
			begin
				// Sprite0 
				sprite0_start	<= 1;
				// Sprite1 
				sprite1_start	<= 1;
				// Sprite2 
				sprite2_start	<= 1;
				
				// A terites vegen van, akkor minden 1bit/pixel-hez tartozo 
				// regiszterbe betolti a kezdoerteket
				if ( lcd_x_ct == 74 && lcd_y_ct_max == 1 ) begin
					lcd_1bp_addr_pointer <= 0;
					lcd_puffer_pointer 	<= 0;
				end
				else begin
					lcd_puffer_pointer 	<= lcd_puffer_pointer   + 1;
					lcd_1bp_addr_pointer <= lcd_1bp_addr_pointer + 1;
				end

				// A terites vegen van, akkor minden 2bit/pixel-hez tartozo 
				// regiszterbe betolti a kezdoerteket
				if ( lcd_x_ct == 77 && lcd_y_ct_max == 1 ) begin
					lcd_2bp_addr_pointer <= 0;
				end
				else begin
					lcd_2bp_addr_pointer <= lcd_2bp_addr_pointer + 1;
				end

				// Text layer RAM olvasas indtas
				if ( lcd_x_ct[0] == 0 ) begin
					text_ready					<= 0; 						// text layer olvasas ok jelzes torles
					mem_req[text_mem_req]	<= text_layer_enable;	// text layer olvasas keres jelzes
					text_addr <= text_start_addr + text_addr_pointer + x_ct[6:1];
				end
				
				// Layer0 RAM olvasas indtas attol fuggoen, hogy 1 vagy 2 bit/pixel modban van
				if ( layer0_bp == 0 ) begin
					if ( lcd_1bp_addr_pointer[1:0] == 3 ) begin
						// Az LCD shift clock jel felfuto elenel LCD memoria hozzaferest kero bit-et 1-be irja.
						layer0_ready 				<= 0;					// layer0 olvasas ok jelzes torles
						mem_req[layer0_mem_req]	<= layer0_enable;	// layer0 olvasas keres jelzes
						layer0_addr[15:0]	 		<= layer0_start_addr + lcd_1bp_addr_pointer[14:2];
					end 
				end else begin
					if ( lcd_2bp_addr_pointer[0] == 0 ) begin
						// Az LCD shift clock jel felfuto elenel LCD memoria hozzaferest kero bit-et 1-be irja.
						layer0_ready 				<= 0; 				 // layer0 olvasas ok jelzes torles
						mem_req[layer0_mem_req]	<= layer0_enable ; // layer0 olvasas keres jelzes
						layer0_addr[15:0] 		<= layer0_start_addr + lcd_2bp_addr_pointer[14:1];
					end
				end

				// Layer1 RAM olvasas indtas attol fuggoen, hogy 1 vagy 2 bit/pixel modban van
				if ( layer1_bp == 0 ) begin
					if ( lcd_1bp_addr_pointer[1:0] == 3 ) begin
						// Az LCD shift clock jel felfuto elenel LCD memoria hozzaferest kero bit-et 1-be irja.
						layer1_ready 				<= 0;					// layer1 olvasas ok jelzes torles
						mem_req[layer1_mem_req]	<= layer1_enable;	// layer1 olvasas keres jelzes
						layer1_addr[15:0] 		<= layer1_start_addr + lcd_1bp_addr_pointer[14:2];
					end 
				end else begin
					if ( lcd_2bp_addr_pointer[0] == 0 ) begin
						// Az LCD shift clock jel felfuto elenel LCD memoria hozzaferest kero bit-et 1-be irja.
						layer1_ready 				<= 0; 				 // layer1 olvasas ok jelzes torles
						mem_req[layer1_mem_req]	<= layer1_enable ; // layer1 olvasas keres jelzes
						layer1_addr[15:0] 		<= layer1_start_addr + lcd_2bp_addr_pointer[14:1];
					end
				end

				// Layer2 RAM olvasas indtas attol fuggoen, hogy 1 vagy 2 bit/pixel modban van
				if ( layer2_bp == 0 ) begin
					if ( lcd_1bp_addr_pointer[1:0] == 3 ) begin
						// Az LCD shift clock jel felfuto elenel LCD memoria hozzaferest kero bit-et 1-be irja.
						layer2_ready 				<= 0;					// layer2 olvasas ok jelzes torles
						mem_req[layer2_mem_req]	<= layer2_enable;	// layer2 olvasas keres jelzes
						layer2_addr[15:0] 		<= layer2_start_addr + lcd_1bp_addr_pointer[14:2];
					end 
				end else begin
					if ( lcd_2bp_addr_pointer[0] == 0 ) begin
						// Az LCD shift clock jel felfuto elenel LCD memoria hozzaferest kero bit-et 1-be irja.
						layer2_ready 				<= 0; 				 // layer2 olvasas ok jelzes torles
						mem_req[layer2_mem_req]	<= layer2_enable ; // layer2 olvasas keres jelzes
						layer2_addr[15:0] 		<= layer2_start_addr + lcd_2bp_addr_pointer[14:1];
					end
				end

				// Layer3 RAM olvasas indtas attol fuggoen, hogy 1 vagy 2 bit/pixel modban van
				if ( layer3_bp == 0 ) begin
					if ( lcd_1bp_addr_pointer[1:0] == 3 ) begin
						// Az LCD shift clock jel felfuto elenel LCD memoria hozzaferest kero bit-et 1-be irja.
						layer3_ready 				<= 0;					// layer3 olvasas ok jelzes torles
						mem_req[layer3_mem_req]	<= layer3_enable;	// layer3 olvasas keres jelzes
						layer3_addr[15:0] 		<= layer3_start_addr + lcd_1bp_addr_pointer[14:2];
					end 
				end else begin
					if ( lcd_2bp_addr_pointer[0] == 0 ) begin
						// Az LCD shift clock jel felfuto elenel LCD memoria hozzaferest kero bit-et 1-be irja.
						layer3_ready 				<= 0; 				 // layer3 olvasas ok jelzes torles
						mem_req[layer3_mem_req]	<= layer3_enable ; // layer3 olvasas keres jelzes
						layer3_addr[15:0] 		<= layer3_start_addr + lcd_2bp_addr_pointer[14:1];
					end
				end

				lcd_strobe_cikl 	<= 0;
				data_mixer_cikl 	<= 1;
				sprite_mixer_cikl <= 1;
			end
	endcase 
	
end

endmodule

