
# PlanAhead Launch Script for Pre-Synthesis Floorplanning, created by Project Navigator

create_project -name Mono_LCD_Spartan3 -dir "F:/backup/Xilinx/Feco/Mono_LCD_Spartan3/planAhead_run_2" -part xc3s400tq144-5
set_param project.pinAheadLayout yes
set srcset [get_property srcset [current_run -impl]]
set_property top LCD $srcset
set_param project.paUcfFile  "F:/backup/Xilinx/Feco/Mono_LCD_Spartan3/Source/Mono_LCD.ucf"
set hdlfile [add_files [list {Source/One_Wire/sr2.v}]]
set_property file_type Verilog $hdlfile
set_property library work $hdlfile
set hdlfile [add_files [list {Source/One_Wire/sr1.v}]]
set_property file_type Verilog $hdlfile
set_property library work $hdlfile
set hdlfile [add_files [list {Source/One_Wire/parallel_sn_data.v}]]
set_property file_type Verilog $hdlfile
set_property library work $hdlfile
set hdlfile [add_files [list {Source/One_Wire/jcnt2.v}]]
set_property file_type Verilog $hdlfile
set_property library work $hdlfile
set hdlfile [add_files [list {Source/One_Wire/jcnt1.v}]]
set_property file_type Verilog $hdlfile
set_property library work $hdlfile
set hdlfile [add_files [list {Source/One_Wire/bitreg.v}]]
set_property file_type Verilog $hdlfile
set_property library work $hdlfile
set hdlfile [add_files [list {Source/One_Wire/onewire_master.v}]]
set_property file_type Verilog $hdlfile
set_property library work $hdlfile
set hdlfile [add_files [list {Source/One_Wire/clk_div.v}]]
set_property file_type Verilog $hdlfile
set_property library work $hdlfile
set hdlfile [add_files [list {Source/One_Wire/onewire_iface.v}]]
set_property file_type Verilog $hdlfile
set_property library work $hdlfile
set hdlfile [add_files [list {Source/Mono_LCD/Sprite.v}]]
set_property file_type Verilog $hdlfile
set_property library work $hdlfile
set hdlfile [add_files [list {Source/Mono_LCD/Pixel_point_plot.v}]]
set_property file_type Verilog $hdlfile
set_property library work $hdlfile
set hdlfile [add_files [list {Source/Mono_LCD/pixel_block.v}]]
set_property file_type Verilog $hdlfile
set_property library work $hdlfile
set hdlfile [add_files [list {Source/Mono_LCD/mem_pri_enc.v}]]
set_property file_type Verilog $hdlfile
set_property library work $hdlfile
set hdlfile [add_files [list {Source/Mono_LCD/lookup_table.v}]]
set_property file_type Verilog $hdlfile
set_property library work $hdlfile
set hdlfile [add_files [list {Source/Mono_LCD/line_draw.v}]]
set_property file_type Verilog $hdlfile
set_property library work $hdlfile
set hdlfile [add_files [list {Source/Mono_LCD/lcd_sync.v}]]
set_property file_type Verilog $hdlfile
set_property library work $hdlfile
set hdlfile [add_files [list {Source/Mono_LCD/Circle.v}]]
set_property file_type Verilog $hdlfile
set_property library work $hdlfile
set hdlfile [add_files [list {Source/IO_source/IO_modul.v}]]
set_property file_type Verilog $hdlfile
set_property library work $hdlfile
set hdlfile [add_files [list {Source/Mono_LCD/Mono_LCD.v}]]
set_property file_type Verilog $hdlfile
set_property library work $hdlfile
add_files "F:/backup/Xilinx/Feco/Mono_LCD_Spartan3/Source/Mono_LCD.ucf" -fileset [get_property constrset [current_run]]
add_files -norecurse { {F:/backup/Xilinx/Feco/Mono_LCD_Spartan3} }
open_rtl_design -part xc3s400tq144-5
